searchNodes=[{"doc":"The rate at which a video file frames are played back, measured in frames-per-second (24/1 = 24 frames-per-second). For more on framerate and why Vtc chooses to represent it as a rational number, see NTSC: Framerate vs timebase and The Rational Rationale Struct Fields playback : The rational representation of the real-world playback speed as a fraction in frames-per-second. ntsc : Atom representing which, if any, NTSC convention this framerate adheres to. Using as an Ecto Type See PgFramerate for information on how to use Framerate in your postgres database as a native type.","ref":"Vtc.Framerate.html","title":"Vtc.Framerate","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Vtc.Framerate.html#embed_as/1","title":"Vtc.Framerate.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Vtc.Framerate.html#equal?/2","title":"Vtc.Framerate.equal?/2","type":"function"},{"doc":"Creates a new Framerate with a playback speed or timebase. Arguments rate : Either the playback rate or timebase. For NTSC framerates, the value will be rounded to the nearest correct value. Options ntsc : Atom representing the which (or whether an) NTSC standard is being used. Default: :non-drop . invert? : If true , the resulting rational rate value will be flipped so that 1/24 becomes 24/1 . This can be helpful when you are parsing a rate given in seconds-per-frame rather than frames-per-second. Default: false . coerce_ntsc? : If true -- and ntsc is non-nil -- values will be coerced to the nearest valid NTSC rate. So 24 would be coerced to 24000/1001 , as would 23.98 . This option must be set to true when ntsc is non-nil and a float is passed. Default: false Float Precision Only floats representing a whole number can be passed for non-NTSC rates, as there is no fully precise way to convert fractional floats to rational values.","ref":"Vtc.Framerate.html#new/2","title":"Vtc.Framerate.new/2","type":"function"},{"doc":"As new/2 but raises an error instead.","ref":"Vtc.Framerate.html#new!/2","title":"Vtc.Framerate.new!/2","type":"function"},{"doc":"Returns true if the value represents and NTSC framerate. Will return true on a Framerate with an :ntsc value of :non_drop and :drop .","ref":"Vtc.Framerate.html#ntsc?/1","title":"Vtc.Framerate.ntsc?/1","type":"function"},{"doc":"The rational representation of the SMPTE timecode's 'logical speed'. For more on timebase and it's relationship to framerate, see: NTSC: Framerate vs timebase . Returned value is in frames-per-second.","ref":"Vtc.Framerate.html#smpte_timebase/1","title":"Vtc.Framerate.smpte_timebase/1","type":"function"},{"doc":"The database type for PgFramerate . Can be used in migrations as the fields type.","ref":"Vtc.Framerate.html#type/0","title":"Vtc.Framerate.type/0","type":"function"},{"doc":"Options for new/2 and new!/2 .","ref":"Vtc.Framerate.html#t:new_opts/0","title":"Vtc.Framerate.new_opts/0","type":"type"},{"doc":"Enum of Ntsc types. Values :non_drop A non-drop NTSC value. :drop A drop-frame ntsc value. nil : Not an NTSC value For more information on NTSC standards and framerate conventions, see Frame.io's blog post on the subject.","ref":"Vtc.Framerate.html#t:ntsc/0","title":"Vtc.Framerate.ntsc/0","type":"type"},{"doc":"Type returned by new/2","ref":"Vtc.Framerate.html#t:parse_result/0","title":"Vtc.Framerate.parse_result/0","type":"type"},{"doc":"Type of Framerate","ref":"Vtc.Framerate.html#t:t/0","title":"Vtc.Framerate.t/0","type":"type"},{"doc":"Identifies a particular frame in a media stream. New Framestamp values are created by with_seconds/3 and with_frames/2 . Vtc's philosophy of working with Timecode is defined by two major conceits: A frame identifier is incomplete without a framerate. More here . All frame identifiers commonly used in Video production boil down to either the real-world seconds-since-midnight that frame occurred, OR a sequential index number. More here . What is a framestamp? Framestamps are a way to identify a media stream frame without requiring any additional information. On a technical level, a framestamp is comprised of: The real-world time that a frame occurred at, as represented by a rational value, measured in seconds since SMPTE timecode &quot;midnight&quot;. The framerate of the media the framestamp was generated for, as represented by a rational frames-per-second value. Any associated metadata about the source representation the framestamp was parsed from, such as SMPTE NTSC non-drop timecode. A fully-formed framestamp for 01:00:00:00 at 23.98 NTSC would be 18018/5 @ 24000/1001 NTSC non-drop . Why prefer seconds? SMPTE timecode is the canonical way frames are identified in professional video workflows. As a human-readable data type, timecode strings are great! You can easily locate, compare, and add timecode strings at-a-glance. Why then, does Vtc come up with a new representation? Well, SMPTE timecode strings are not as great for computers. Let's take a quick look at what we want from a good frame identifier: Uniquely identifies a frame in a specific video stream. Sortable by real-world occurrence. Easily added/subtracted to each other. All of the above, in mixed-framerate contexts. The last point is key, timecode is great... if all of your media is running at the same framerate. For instance, when syncing media streams between two devices -- one running at 24fps, and one running at 48fps -- 01:00:00:13 and 01:00:00:26 are equivalent values, as they were captured at the same point in time, and should be synced together. Timecode is an expression of frame index more than frame seconds , and as such, cannot be lexically sorted in mixed-rate settings. Further, a computer cannot add &quot;01:30:00:00&quot; to &quot;01:00:00:00&quot; without converting it to some sort of numerical value. Many programs convert timecode directly to an integer frame number for arithmetic and comparison operations where each frame on the clock is issued a continuous index, with 0 as 00:00:00:00 . Frame numbers, though, have the same issue with mixed-rate values as timecode; 26 at 48 frames-per-second represents the same real-world time as 13 at 24 frames-per-seconds, and preserving that equality is important for operations like jam-syncing. So that leaves us with real-world seconds. Convert timecode values -- even ones captured in mixed rates -- to seconds, then add and sort to your heart's content. Why rational numbers? We'll avoid a deep-dive over why we use a rational value over a float or decimal, but you can read more on that choice here . The short version is that many common SMPTE-specified framerates are defined as irrational numbers. For instance, 23.98 NTSC is defined as 24000/1001 frames-per-second. In order to avoid off-by-one errors when using seconds , we need to avoid resolving values like 1001/24000 -- the value for frame 1 at 23.98 NTSC -- into any sort of decimal representation, since 1001/24000 is an irrational value and cannot be cleanly represented as a decimal. It's digits ride off into the sunset. Why include framerate? SMPTE timecode does not include a framerate in it's specification for frame identifiers, i.e 01:00:00:00 . So why does Vtc? Lets say that we are working with a given video file, and you are handed the timecode 01:00:00:12 . What frame does that belong to? Without a framerate, you cannot know. If we are talking about 23.98 NTSC media, it belongs to frame 86,400 , but if we are talking about 59.94 NTSC NDF , frame then it belongs to frame 216,000 , and if we are talking about 59.94 NTSC DF media then it belongs to frame 215,784 . What about the other direction? We need to calculate the SMPTE timecode for frame 48 , which we previously parsed from a timecode. Well if it was originally parsed using 23.98 NTSC footage, then it is TC 00:00:02:00 , but if it is 59.94 NTSC then it is TC 00:00:00:48 . Framerate is implicitly required for a SMPTE timecode to be comprehensible. The story is the same with seconds. How many seconds does 01:00:00:00 represent? At 23.98 NTSC , it represents 18018/5 seconds, but at 24fps true it represents 3600/1 seconds. We cannot know what frame a seconds value represents, or what seconds value a frame represents, without knowing that scalar value's associated framerate. It's like having a timestamp without a timezone. Even in systems where all timestamps are converted to UTC, we often keep the timezone information around because it's just too useful in mixed-timezone settings, and you can't be sure what a given timestamp represents in a vacuum if you don't have the associated timezone. Framerate -- especially in mixed rate settings, which Vtc considers a first-class use case -- is required to sensibly execute many operations, like casting in an out of SMPTE Timecode, adding two timecodes together, etc. For this reason we package the framerate of our media stream together with the scalar value that represents a frame in that stream, and take the onus of transporting these two values together off of the caller. Struct Fields seconds : The real-world seconds elapsed since 'midnight' as a rational value. rate : the Framerate of the Framestamp . Parsing: Seconds.t() or Frames.t() Parsing functions pre-append with_ to their name. When you give a value to a parsing function, it is the same value that would be returned by the equivalent unit conversion. So a value passed to with_frames is the same value frames would return: iex&gt; { :ok , framestamp } = Framestamp . with_frames ( 24 , Rates . f23_98 ( ) ) iex&gt; inspect ( framestamp ) &quot;&lt;00:00:01:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; Framestamp . frames ( framestamp ) 24 The Framestamp module only has two basic construction / parsing methods: with_seconds and with_frames . At first blush, this may seem... odd. Where is with_timecode/2 ? Or with_premiere_ticks/2 ? We can render these formats, so why isn't there a parser for them? Well there is, sort of: the two functions above. Vtc's second major conceit is that all of the various ways of representing a video frame's timestamp boil down to EITHER: a) A representation of an index number for that frame OR b) A representation of the real-world seconds the frame occurred at. SMPTE timecode is really a human-readable way to represent a frame number. Same with film feet+frames. Premiere Ticks, on the other hand, represents a real-world seconds value, as broken down in 1/254_016_000_000ths of a second. Instead of polluting the module's namespace with a range of constructors, Vtc declares a Frames protocol for types that represent a frame count, and a Seconds protocol for types that represent a time-scalar. All framestamp representations eventually get funneled through one of these protocols. For instance, when the String implementation of the protocol detects a SMPTE timecode string, it wraps the value in a SMPTETimecodeStr struct which handles converting that string to a frame number thorough implementing the Frames protocol. That frame number is then taken by with_frames and converted to a rational seconds value. Going through protocols allows callers to define their own types that work with Vtc's parsing functions directly. Sorting Support Framestamp implements compare/2 , and as such, can be used wherever the standard library calls for a Sorter module. Let's see it in action: iex&gt; stamp_01 = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; stamp_02 = Framestamp . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; sorted = Enum . sort ( [ stamp_02 , stamp_01 ] , Framestamp ) iex&gt; inspect ( sorted ) &quot;[&lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;, &lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;]&quot; iex&gt; sorted = Enum . sort ( [ stamp_01 , stamp_02 ] , { :desc , Framestamp } ) iex&gt; inspect ( sorted ) &quot;[&lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;, &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;]&quot; iex&gt; max = Enum . max ( [ stamp_02 , stamp_01 ] , Framestamp ) iex&gt; inspect ( max ) &quot;&lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; min = Enum . min ( [ stamp_02 , stamp_01 ] , Framestamp ) iex&gt; inspect ( min ) &quot;&lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; data_01 = %{ id : 2 , tc : stamp_01 } iex&gt; data_02 = %{ id : 1 , tc : stamp_02 } iex&gt; sorted = Enum . sort_by ( [ data_02 , data_01 ] , &amp; &amp;1 . tc , Framestamp ) iex&gt; inspect ( sorted ) &quot;[%{id: 2, tc: &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}, %{id: 1, tc: &lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;}]&quot; Arithmetic Autocasting For operators that take two Framestamp values, like add/3 or compare/2 , as long as one argument is a Framestamp value, a or b May be any value that implements the Frames protocol, such as a timecode string, and will be assumed to be the same framerate as the other. Production code Autocasting exists to support quick scratch scripts and we suggest that it not be relied upon in production application code. If parsing the value fails during casting, the function raises a Vtc.Framestamp.ParseError . Using as an Ecto Type See PgFramestamp for information on how to use Framerate in your postgres database as a native type.","ref":"Vtc.Framestamp.html","title":"Vtc.Framestamp","type":"module"},{"doc":"Returns the absolute value of tc . Examples iex&gt; stamp = Framestamp . with_frames! ( &quot;-01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . abs ( stamp ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; stamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . abs ( stamp ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.html#abs/1","title":"Vtc.Framestamp.abs/1","type":"function"},{"doc":"Add two framestamps. Uses the real-world seconds representation. When the rates of a and b are not equal, the result will inherit the framerate of a and be rounded to the seconds representation of the nearest whole-frame at that rate. auto-casts Frames values. Options inherit_rate : Which side to inherit the framerate from in mixed-rate calculations. If false , this function will raise if a.rate does not match b.rate . Default: false . round : How to round the result with respect to whole-frames when mixing framerates. Default: :closest . Examples Two framestamps running at the same rate: iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;01:30:21:17&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . add ( a , b ) iex&gt; inspect ( result ) &quot;&lt;02:30:21:17 &lt;23.98 NTSC&gt;&gt;&quot; Two framestamps running at different rates: iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:02&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;00:00:00:02&quot; , Rates . f47_95 ( ) ) iex&gt; iex&gt; result = Framestamp . add ( a , b , inherit_rate : :left ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:03 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; iex&gt; result = Framestamp . add ( a , b , inherit_rate : :right ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:06 &lt;47.95 NTSC&gt;&gt;&quot; If :inherit_rate is not set... iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:02&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;00:00:00:02&quot; , Rates . f47_95 ( ) ) iex&gt; Framestamp . add ( a , b ) ** (Vtc.Framestamp.MixedRateArithmeticError) attempted `Framestamp.add(a, b)` where `a.rate` does not match `b.rate`. try `:inherit_rate` option to `:left` or `:right`. alternatively, do your calculation in seconds, then cast back to `Framestamp` with the appropriate framerate using `with_seconds/3` Using a framestamps and a bare string: iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . add ( a , &quot;01:30:21:17&quot; ) iex&gt; inspect ( result ) &quot;&lt;02:30:21:17 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.html#add/3","title":"Vtc.Framestamp.add/3","type":"function"},{"doc":"Compare the values of a and b . Compatible with Enum.sort/2 . For more on sorting non-builtin values, see the Elixir documentation . auto-casts Frames values. See eq?/2 for more information on how equality is determined. Examples Using two framestamps parsed from SMPTE timecode, 01:00:00:00 NTSC is greater than 01:00:00:00 true because it represents more real-world time. iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f24 ( ) ) iex&gt; :gt = Framestamp . compare ( a , b ) Using a framestamp and a bare string: iex&gt; framestamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; :eq = Framestamp . compare ( framestamp , &quot;01:00:00:00&quot; )","ref":"Vtc.Framestamp.html#compare/2","title":"Vtc.Framestamp.compare/2","type":"function"},{"doc":"Divides dividend by divisor . The result will inherit the framerate of dividend and rounded to the nearest whole-frame based on the :round option. Options round : How to round the result with respect to whole-frame values. Defaults to :trunc to match divmod and the expected meaning of div to mean integer division in elixir. Examples iex&gt; dividend = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . div ( dividend , 2 ) iex&gt; inspect ( result ) &quot;&lt;00:30:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; dividend = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . div ( dividend , 0.5 ) iex&gt; inspect ( result ) &quot;&lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.html#div/3","title":"Vtc.Framestamp.div/3","type":"function"},{"doc":"Divides the total frame count of dividend by divisor and returns both a quotient and a remainder. The quotient returned is equivalent to Framestamp.div/3 with the :round option set to :trunc . Options round_frames : How to round the frame count before doing the divrem operation. Default: :closest . round_remainder : How to round the remainder frames when a non-whole frame would be the result. Default: :closest . Examples iex&gt; dividend = Framestamp . with_frames! ( &quot;01:00:00:01&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . divrem ( dividend , 4 ) iex&gt; inspect ( result ) &quot;{&lt;00:15:00:00 &lt;23.98 NTSC&gt;&gt;, &lt;00:00:00:01 &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"Vtc.Framestamp.html#divrem/3","title":"Vtc.Framestamp.divrem/3","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Vtc.Framestamp.html#embed_as/1","title":"Vtc.Framestamp.embed_as/1","type":"function"},{"doc":"Returns true if a is equal to b . auto-casts Frames values. Examples iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; true = Framestamp . eq? ( a , b ) Framestamps with the same string timecode representation, but different real-world seconds values, are not equal: iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f24 ( ) ) iex&gt; false = Framestamp . eq? ( a , b ) But Framestamps with the different SMPTE timecode string representation, but the same real-world seconds values, are equal: iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:12&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;01:00:00:24&quot; , Rates . f47_95 ( ) ) iex&gt; true = Framestamp . eq? ( a , b )","ref":"Vtc.Framestamp.html#eq?/2","title":"Vtc.Framestamp.eq?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Vtc.Framestamp.html#equal?/2","title":"Vtc.Framestamp.equal?/2","type":"function"},{"doc":"Evaluates Framestamp mathematical expressions in a do block. Any code captured within this macro can use Kernel operators to work with Framestamp values instead of module functions like add/2 . Options at : The Framerate to cast non- Framestamp values to. If this value is not set, then at least one value in each operation must be a Framestamp . This value can be any value accepted by Framerate.new/2 . ntsc : The ntsc value to use when creating a new Framerate with at . Not needed if at is a Framerate value. Examples Use eval to do some quick math. The block captures variables from the outer scope, but contains the expression within its own scope, just like an if or with statement. iex&gt; require Framestamp iex&gt; iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;00:30:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; c = Framestamp . with_frames! ( &quot;00:15:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = iex&gt; Framestamp . eval do iex&gt; a + b * 2 - c iex&gt; end iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; Or if you want to do it in one line: iex&gt; require Framestamp iex&gt; iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;00:30:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; c = Framestamp . with_frames! ( &quot;00:15:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . eval ( a + b * 2 - c ) iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; Just like the regular Framestamp functions, only one value in an arithmetic expression needs to be a Framestamp value. In the case above, since multiplication happens first, that's b : iex&gt; b = Framestamp . with_frames! ( &quot;00:30:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = iex&gt; Framestamp . eval do iex&gt; &quot;01:00:00:00&quot; + b * 2 - &quot;00:15:00:00&quot; iex&gt; end iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; You can supply a default framerate if you just want to do some quick calculations. This framerate is inherited by every value that implements the Frames protocol in the block, including integers: iex&gt; result = iex&gt; Framestamp . eval at : Rates . f23_98 ( ) do iex&gt; &quot;01:00:00:00&quot; + &quot;00:30:00:00&quot; * 2 - &quot;00:15:00:00&quot; iex&gt; end iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; You can use any value that can be parsed by Framerate.new/2 . iex&gt; result = iex&gt; Framestamp . eval at : 23.98 do iex&gt; &quot;01:00:00:00&quot; + &quot;00:30:00:00&quot; * 2 - &quot;00:15:00:00&quot; iex&gt; end iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; ntsc: :non_drop, coerce_ntsc?: true is assumed by default, but you can set a different value with the :ntsc option: iex&gt; result = iex&gt; Framestamp . eval at : 24 , ntsc : nil do iex&gt; &quot;01:00:00:00&quot; + &quot;00:30:00:00&quot; * 2 - &quot;00:15:00:00&quot; iex&gt; end iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;24.0 fps&gt;&gt;&quot;","ref":"Vtc.Framestamp.html#eval/2","title":"Vtc.Framestamp.eval/2","type":"macro"},{"doc":"Returns the number of physical film feet and frames framestamp represents if shot on film. Ex: '5400+13'. Options round : How to round the internal frame count before conversion. Default: :closest . film_format : The film format to use when doing the calculation. For more on film formats, see Vtc.FilmFormat . Default: :ff35mm_4perf , by far the most common format used to shoot Hollywood movies. What it is On physical film, each foot contains a certain number of frames. For 35mm, 4-perf film (the most common type on Hollywood movies), this number is 16 frames per foot. Feet-And-Frames was often used in place of Keycode to quickly reference a frame in the edit. Where you see it For the most part, feet + frames has died out as a reference, because digital media is not measured in feet. The most common place it is still used is Studio Sound Departments. Many Sound Mixers and Designers intuitively think in feet + frames, and it is often burned into the reference picture for them. Telecine. Sound turnover reference picture. Sound turnover change lists. For more information on individual film formats, see the Vtc.FilmFormat module. Examples Defaults to 35mm, 4perf: iex&gt; framestamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . feet_and_frames ( framestamp ) iex&gt; inspect ( result ) &quot;&lt;5400+00 :ff35mm_4perf&gt;&quot; Use String.Chars to convert the resulting struct to a traditional F=F string: iex&gt; alias Vtc.Source.Frames.FeetAndFrames iex&gt; iex&gt; framestamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . feet_and_frames ( framestamp ) iex&gt; String.Chars . to_string ( result ) &quot;5400+00&quot; Outputting as a different film format: Examples iex&gt; framestamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . feet_and_frames ( framestamp , film_format : :ff16mm ) iex&gt; inspect ( result ) &quot;&lt;4320+00 :ff16mm&gt;&quot;","ref":"Vtc.Framestamp.html#feet_and_frames/2","title":"Vtc.Framestamp.feet_and_frames/2","type":"function"},{"doc":"Returns the number of frames that would have elapsed between 00:00:00:00 and Framestamp . Options round : How to round the resulting frame number. What it is Frame number / frames count is the number of a frame if the SMPTE timecode started at 00:00:00:00 and had been running until the current value. A SMPTE timecode of '00:00:00:10' has a frame number of 10. A SMPTE timecode of '01:00:00:00' has a frame number of 86400. Where you see it Frame-sequence files: 'my_vfx_shot.0086400.exr' FCP7XML cut lists: &lt;timecode&gt; &lt;rate&gt; &lt;timebase&gt;24&lt;/timebase&gt; &lt;ntsc&gt;TRUE&lt;/ntsc&gt; &lt;/rate&gt; &lt;string&gt;01:00:00:00&lt;/string&gt; &lt;frame&gt;86400&lt;/frame&gt; &lt;!-- &lt;====THIS LINE--&gt; &lt;displayformat&gt;NDF&lt;/displayformat&gt; &lt;/timecode&gt; Examples iex&gt; framestamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Framestamp . frames ( framestamp ) 86400","ref":"Vtc.Framestamp.html#frames/2","title":"Vtc.Framestamp.frames/2","type":"function"},{"doc":"Returns true if a is greater than b . auto-casts Frames values. See eq?/2 for more information on how equality is determined.","ref":"Vtc.Framestamp.html#gt?/2","title":"Vtc.Framestamp.gt?/2","type":"function"},{"doc":"Returns true if a is greater than or equal to b . auto-casts Frames values. See eq?/2 for more information on how equality is determined.","ref":"Vtc.Framestamp.html#gte?/2","title":"Vtc.Framestamp.gte?/2","type":"function"},{"doc":"Returns true if a is less than b . auto-casts Frames values. See eq?/2 for more information on how equality is determined. Examples iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; true = Framestamp . lt? ( a , b ) iex&gt; false = Framestamp . lt? ( b , a )","ref":"Vtc.Framestamp.html#lt?/2","title":"Vtc.Framestamp.lt?/2","type":"function"},{"doc":"Returns true if a is less than or equal to b . auto-casts Frames values. See eq?/2 for more information on how equality is determined.","ref":"Vtc.Framestamp.html#lte?/2","title":"Vtc.Framestamp.lte?/2","type":"function"},{"doc":"As the kernel -/1 function. Makes a positive tc value negative. Makes a negative tc value positive. Examples iex&gt; stamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . minus ( stamp ) iex&gt; inspect ( result ) &quot;&lt;-01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; stamp = Framestamp . with_frames! ( &quot;-01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . minus ( stamp ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.html#minus/1","title":"Vtc.Framestamp.minus/1","type":"function"},{"doc":"Scales a by b . The result will inherit the framerate of a and be rounded to the seconds representation of the nearest whole-frame based on the :round option. Options round : How to round the result with respect to whole-frame values. Defaults to :closest . Examples iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . mult ( a , 2 ) iex&gt; inspect ( result ) &quot;&lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . mult ( a , 0.5 ) iex&gt; inspect ( result ) &quot;&lt;00:30:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.html#mult/3","title":"Vtc.Framestamp.mult/3","type":"function"},{"doc":"Returns the number of elapsed ticks framestamp represents in Adobe Premiere Pro. Options round : How to round the resulting ticks. What it is Internally, Adobe Premiere Pro uses ticks to divide up a second, and keep track of how far into that second we are. There are 254016000000 ticks in a second, regardless of framerate in Premiere. Where you see it Premiere Pro Panel functions and scripts. FCP7XML cutlists generated from Premiere: &lt;clipitem id=&quot;clipitem-1&quot;&gt; ... &lt;in&gt;158&lt;/in&gt; &lt;out&gt;1102&lt;/out&gt; &lt;pproTicksIn&gt;1673944272000&lt;/pproTicksIn&gt; &lt;pproTicksOut&gt;11675231568000&lt;/pproTicksOut&gt; ... &lt;/clipitem&gt; Examples iex&gt; framestamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Framestamp . premiere_ticks ( framestamp ) 915372057600000","ref":"Vtc.Framestamp.html#premiere_ticks/2","title":"Vtc.Framestamp.premiere_ticks/2","type":"function"},{"doc":"Rebases framestamp to a new framerate. The real-world seconds are recalculated using the same frame count as if they were being played back at new_rate instead of framestamp.rate . Examples iex&gt; framestamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; { :ok , rebased } = Framestamp . rebase ( framestamp , Rates . f47_95 ( ) ) iex&gt; inspect ( rebased ) &quot;&lt;00:30:00:00 &lt;47.95 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.html#rebase/2","title":"Vtc.Framestamp.rebase/2","type":"function"},{"doc":"As rebase/2 , but raises on error.","ref":"Vtc.Framestamp.html#rebase!/2","title":"Vtc.Framestamp.rebase!/2","type":"function"},{"doc":"Divides the total frame count of dividend by devisor , and returns the remainder. The quotient is truncated before the remainder is calculated. Options round_frames : How to round the frame count before doing the rem operation. Default: :closest . round_remainder : How to round the remainder frames when a non-whole frame would be the result. Default: :closest . Examples iex&gt; dividend = Framestamp . with_frames! ( &quot;01:00:00:01&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . rem ( dividend , 4 ) iex&gt; inspect ( result ) &quot;&lt;00:00:00:01 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.html#rem/3","title":"Vtc.Framestamp.rem/3","type":"function"},{"doc":"Runtime Returns the true, real-world runtime of framestamp in HH:MM:SS.FFFFFFFFF format. Trailing zeroes are trimmed from the end of the return value. If the entire fractal seconds value would be trimmed, '.0' is used. Options precision : The number of places to round to. Extra trailing 0's will still be trimmed. Default: 9 . trim_zeros? : Whether to trim trailing zeroes. Default: true . What it is The human-readable version of seconds . It looks like timecode, but with a decimal seconds value instead of a frame number place. Where you see it • Anywhere real-world time is used. • FFMPEG commands: ffmpeg -ss 00:00:30.5 -i input.mov -t 00:00:10.25 output.mp4 Note The true runtime will often diverge from the hours, minutes, and seconds value of the SMPTE timecode representation when dealing with non-whole-frame framerates. Even drop-frame timecode does not continuously adhere 1:1 to the actual runtime. For instance, &lt;01:00:00;00 &lt;29.97 NTSC DF&gt;&gt; has a true runtime of '00:59:59.9964', and &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt; has a true runtime of '01:00:03.6' Examples iex&gt; framestamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Framestamp . runtime ( framestamp ) &quot;01:00:03.6&quot;","ref":"Vtc.Framestamp.html#runtime/2","title":"Vtc.Framestamp.runtime/2","type":"function"},{"doc":"Returns the the formatted SMPTE timecode for a Framestamp . Ex: 01:00:00:00 . Drop frame timecode will be rendered with a ';' separator before the frames field. Options round : How to round the resulting frames field. What it is Timecode is used as a human-readable way to represent the id of a given frame. It is formatted to give a rough sense of where to find a frame: {HOURS}:{MINUTES}:{SECONDS}:{FRAME} . For more on timecode, see Frame.io's excellent post on the subject. Where you see it Timecode is ubiquitous in video editing, a small sample of places you might see timecode: Source and Playback monitors in your favorite NLE. Burned into the footage for dailies. Cut lists like an EDL. Examples iex&gt; framestamp = Framestamp . with_frames! ( 86_400 , Rates . f23_98 ( ) ) iex&gt; Framestamp . smpte_timecode ( framestamp ) &quot;01:00:00:00&quot;","ref":"Vtc.Framestamp.html#smpte_timecode/2","title":"Vtc.Framestamp.smpte_timecode/2","type":"function"},{"doc":"The individual sections of a SMPTE timecode string as i64 values. Examples iex&gt; framestamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . smpte_timecode_sections ( framestamp ) iex&gt; inspect ( result ) &quot;%Vtc.SMPTETimecode.Sections{negative?: false, hours: 1, minutes: 0, seconds: 0, frames: 0}&quot;","ref":"Vtc.Framestamp.html#smpte_timecode_sections/2","title":"Vtc.Framestamp.smpte_timecode_sections/2","type":"function"},{"doc":"Subtract b from a . Uses their real-world seconds representation. When the rates of a and b are not equal, the result will inherit the framerate of a and be rounded to the seconds representation of the nearest whole-frame at that rate. auto-casts Frames values. Options inherit_rate : Which side to inherit the framerate from in mixed-rate calculations. If false , this function will raise if a.rate does not match b.rate . Default: false . round : How to round the result with respect to whole-frames when mixing framerates. Default: :closest . Examples Two framestamps running at the same rate: iex&gt; a = Framestamp . with_frames! ( &quot;01:30:21:17&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . sub ( a , b ) iex&gt; inspect ( result ) &quot;&lt;00:30:21:17 &lt;23.98 NTSC&gt;&gt;&quot; Two framestamps running at different rates: iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:02&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;00:00:00:02&quot; , Rates . f47_95 ( ) ) iex&gt; iex&gt; result = Framestamp . sub ( a , b , inherit_rate : :left ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:01 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; iex&gt; result = Framestamp . sub ( a , b , inherit_rate : :right ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:02 &lt;47.95 NTSC&gt;&gt;&quot; If :inherit_rate is not set... iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:02&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;00:00:00:02&quot; , Rates . f47_95 ( ) ) iex&gt; Framestamp . sub ( a , b ) ** (Vtc.Framestamp.MixedRateArithmeticError) attempted `Framestamp.sub(a, b)` where `a.rate` does not match `b.rate`. try `:inherit_rate` option to `:left` or `:right`. alternatively, do your calculation in seconds, then cast back to `Framestamp` with the appropriate framerate using `with_seconds/3` When b is greater than a , the result is negative: iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . sub ( a , b ) iex&gt; inspect ( result ) &quot;&lt;-01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; Using a framestamps and a bare string: iex&gt; a = Framestamp . with_frames! ( &quot;01:30:21:17&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Framestamp . sub ( a , &quot;01:00:00:00&quot; ) iex&gt; inspect ( result ) &quot;&lt;00:30:21:17 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.html#sub/3","title":"Vtc.Framestamp.sub/3","type":"function"},{"doc":"The database type for PgFramestamp . Can be used in migrations as the fields type.","ref":"Vtc.Framestamp.html#type/0","title":"Vtc.Framestamp.type/0","type":"function"},{"doc":"Adds all constraints created by PgFramestamp.Migrations.create_constraints/3 to changeset to be added as changeset errors rather than raised. Options Pass the same options that were passed to PgFramestamp.Migrations.create_constraints/3","ref":"Vtc.Framestamp.html#validate_constraints/3","title":"Vtc.Framestamp.validate_constraints/3","type":"function"},{"doc":"Returns a new Framestamp with a frames/2 return value equal to the frames arg. Arguments frames : A value which can be represented as a frame number / frame count. Must implement the Frames protocol. rate : Frame-per-second playback value of the framestamp. Options round : How to round the result with regards to whole-frames. Default: :closest . Examples Accepts SMPTE timecode strings... iex&gt; result = Framestamp . with_frames ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}&quot; ... feet+frames strings... iex&gt; result = Framestamp . with_frames ( &quot;5400+00&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}&quot; By default, feet+frames is interpreted as 35mm, 4perf film. You can use the FeetAndFrames struct to parse other film formats: iex&gt; alias Vtc.Source.Frames.FeetAndFrames iex&gt; iex&gt; { :ok , feet_and_frames } = FeetAndFrames . from_string ( &quot;5400+00&quot; , film_format : :ff16mm ) iex&gt; iex&gt; result = Framestamp . with_frames ( feet_and_frames , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:15:00:00 &lt;23.98 NTSC&gt;&gt;}&quot; ... integers... iex&gt; result = Framestamp . with_frames ( 86_400 , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}&quot; ... and integer strings. iex&gt; result = Framestamp . with_frames ( &quot;86400&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"Vtc.Framestamp.html#with_frames/2","title":"Vtc.Framestamp.with_frames/2","type":"function"},{"doc":"As Framestamp.with_frames/3 , but raises on error.","ref":"Vtc.Framestamp.html#with_frames!/2","title":"Vtc.Framestamp.with_frames!/2","type":"function"},{"doc":"Returns a new Framestamp with a :seconds field value equal to the seconds arg. Arguments seconds : A value which can be represented as a number of real-world seconds. Must implement the Seconds protocol. rate : Frame-per-second playback value of the framestamp. Options round : How to round the result with regards to whole-frames. If set to :off , will return an error if the provided seconds value does not exactly represent a whole-number frame count. Default: :closest . Examples Accepts runtime strings... iex&gt; result = Framestamp . with_seconds ( &quot;01:00:00.5&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;00:59:56:22 &lt;23.98 NTSC&gt;&gt;}&quot; ... floats... iex&gt; result = Framestamp . with_seconds ( 3600.5 , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;00:59:56:22 &lt;23.98 NTSC&gt;&gt;}&quot; ... integers... iex&gt; result = Framestamp . with_seconds ( 3600 , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;00:59:56:10 &lt;23.98 NTSC&gt;&gt;}&quot; ... integer strings... iex&gt; result = Framestamp . with_seconds ( &quot;3600&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;00:59:56:10 &lt;23.98 NTSC&gt;&gt;}&quot; ... and float strings. iex&gt; result = Framestamp . with_seconds ( &quot;3600.5&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;00:59:56:22 &lt;23.98 NTSC&gt;&gt;}&quot; Premiere Ticks The Vtc.Source.Seconds.PremiereTicks struck implements the Seconds protocol and can be used to parse the format. This struct is not a general-purpose Module for the unit, and only exists to hint to the parsing function how it should be processed: iex&gt; alias Vtc.Source.Seconds.PremiereTicks iex&gt; iex&gt; input = % PremiereTicks { in : 254_016_000_000 } iex&gt; iex&gt; result = Framestamp . with_seconds! ( input , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;&lt;00:00:01:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.html#with_seconds/3","title":"Vtc.Framestamp.with_seconds/3","type":"function"},{"doc":"As with_seconds/3 , but raises on error.","ref":"Vtc.Framestamp.html#with_seconds!/3","title":"Vtc.Framestamp.with_seconds!/3","type":"function"},{"doc":"Describes which side to inherit the framerate from in mixed-rate arithmetic.","ref":"Vtc.Framestamp.html#t:inherit_opt/0","title":"Vtc.Framestamp.inherit_opt/0","type":"type"},{"doc":"Type returned by with_seconds/3 and with_frames/3 .","ref":"Vtc.Framestamp.html#t:parse_result/0","title":"Vtc.Framestamp.parse_result/0","type":"type"},{"doc":"Valid values for rounding options. :closest : Round the to the closet whole frame. Rounds away from zero when value is equidistant from two whole-frames. :floor : Always round down to the closest whole-frame. Negative numbers round away from zero :ciel : Always round up to the closest whole-frame. Negative numbers round towards zero. :trunc : Always round towards zero to the closest whole frame. Negative numbers round up and positive numbers round down. :off : Do not round. Will always raise if result would represent a non-whole-frame value.","ref":"Vtc.Framestamp.html#t:round/0","title":"Vtc.Framestamp.round/0","type":"type"},{"doc":"Framestamp type.","ref":"Vtc.Framestamp.html#t:t/0","title":"Vtc.Framestamp.t/0","type":"type"},{"doc":"Holds a framestamp range. Struct Fields in : Start TC. Must be less than or equal to out . out : End TC. Must be greater than or equal to in . inclusive : See below for more information. Default: false Inclusive vs. Exclusive Ranges Inclusive ranges treat the out framestamp as the last visible frame of a piece of footage. This style of timecode range is most often associated with AVID. Exclusive framestamp ranges treat the out framestamp as the boundary where the range ends. This style of timecode range is most often associated with Final Cut and Premiere. In mathematical notation, inclusive ranges are [in, out] , while exclusive ranges are [in, out) .","ref":"Vtc.Framestamp.Range.html","title":"Vtc.Framestamp.Range","type":"module"},{"doc":"Returns true if range contains framestamp . framestamp may be any value that implements Frames . Examples iex&gt; stamp_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; range = Range . new! ( stamp_in , &quot;01:30:00:00&quot; ) iex&gt; iex&gt; Range . contains? ( range , &quot;01:10:00:00&quot; ) true iex&gt; Range . contains? ( range , &quot;01:40:00:00&quot; ) false","ref":"Vtc.Framestamp.Range.html#contains?/2","title":"Vtc.Framestamp.Range.contains?/2","type":"function"},{"doc":"Returns the duration in Framestamp of range . Examples iex&gt; stamp_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; range = Range . new! ( stamp_in , &quot;01:30:00:00&quot; ) iex&gt; iex&gt; result = Range . duration ( range ) iex&gt; inspect ( result ) &quot;&lt;00:30:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.Range.html#duration/1","title":"Vtc.Framestamp.Range.duration/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Vtc.Framestamp.Range.html#embed_as/1","title":"Vtc.Framestamp.Range.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Vtc.Framestamp.Range.html#equal?/2","title":"Vtc.Framestamp.Range.equal?/2","type":"function"},{"doc":"Returns the the range where a and b overlap/intersect. Returns {:error, :none} if the two ranges do not intersect. Options inherit_rate : Which side to inherit the framerate from in mixed-rate calculations. If false , this function will raise if a 's rate does not match b 's rate. Default: false . inherit_out_type : Which side to inherit the out type from when a.out_type does not match b.out_type . If false , this function will raise if a 's rate does not match b 's rate. Default: false . Examples iex&gt; a_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Framestamp . with_frames! ( &quot;01:50:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;02:30:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; result = Range . intersection ( a , b ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:50:00:00 - 02:00:00:00 :inclusive &lt;23.98 NTSC&gt;&gt;}&quot; iex&gt; a_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Framestamp . with_frames! ( &quot;02:10:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;03:30:00:00&quot; , out_type : :inclusive ) iex&gt; Range . intersection ( a , b ) { :error , :none }","ref":"Vtc.Framestamp.Range.html#intersection/3","title":"Vtc.Framestamp.Range.intersection/3","type":"function"},{"doc":"As intersection , but returns a Range from 00:00:00:00 - 00:00:00:00 when there is no overlap. Options inherit_rate : Which side to inherit the framerate from in mixed-rate calculations. If false , this function will raise if a 's rate does not match b 's rate. Default: false . inherit_out_type : Which side to inherit the out type from when a.out_type does not match b.out_type . If false , this function will raise if a 's rate does not match b 's rate. Default: false . Examples iex&gt; a_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Framestamp . with_frames! ( &quot;02:10:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;03:30:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; result = Range . intersection! ( a , b ) iex&gt; inspect ( result ) &quot;&lt;00:00:00:00 - -00:00:00:01 :inclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.Range.html#intersection!/3","title":"Vtc.Framestamp.Range.intersection!/3","type":"function"},{"doc":"Creates a new Range . out_tc may be a Framestamp value for any value that implements the Frames protocol. Returns an error if the resulting range would not have a duration greater or equal to 0, or if stamp_in and stamp_out do not have the same rate . Examples iex&gt; stamp_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; stamp_out = Framestamp . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . new ( stamp_in , stamp_out ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;}&quot; Using a timecode string as b : iex&gt; stamp_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . new ( stamp_in , &quot;02:00:00:00&quot; ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;}&quot; Making a range with an inclusive out: iex&gt; stamp_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . new ( stamp_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 02:00:00:00 :inclusive &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"Vtc.Framestamp.Range.html#new/3","title":"Vtc.Framestamp.Range.new/3","type":"function"},{"doc":"As new/3 , but raises on error.","ref":"Vtc.Framestamp.Range.html#new!/3","title":"Vtc.Framestamp.Range.new!/3","type":"function"},{"doc":"Returns true if there is overlap between a and b . Examples iex&gt; a_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Framestamp . with_frames! ( &quot;01:50:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;02:30:00:00&quot; , out_type : :inclusive ) iex&gt; Range . overlaps? ( a , b ) true iex&gt; a_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Framestamp . with_frames! ( &quot;02:10:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;03:30:00:00&quot; , out_type : :inclusive ) iex&gt; Range . overlaps? ( a , b ) false","ref":"Vtc.Framestamp.Range.html#overlaps?/2","title":"Vtc.Framestamp.Range.overlaps?/2","type":"function"},{"doc":"Returns the range between two, non-overlapping ranges. Returns {:error, :none} if the two ranges are not separated. Options inherit_rate : Which side to inherit the framerate from in mixed-rate calculations. If false , this function will raise if a 's rate does not match b 's rate. Default: false . inherit_out_type : Which side to inherit the out type from when a.out_type does not match b.out_type . If false , this function will raise if a 's rate does not match b 's rate. Default: false . Examples iex&gt; a_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Framestamp . with_frames! ( &quot;02:10:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;03:30:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; result = Range . separation ( a , b ) iex&gt; inspect ( result ) &quot;{:ok, &lt;02:00:00:01 - 02:09:59:23 :inclusive &lt;23.98 NTSC&gt;&gt;}&quot; iex&gt; a_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Framestamp . with_frames! ( &quot;01:50:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;02:30:00:00&quot; , out_type : :inclusive ) iex&gt; Range . separation ( a , b ) { :error , :none }","ref":"Vtc.Framestamp.Range.html#separation/3","title":"Vtc.Framestamp.Range.separation/3","type":"function"},{"doc":"As separation , but returns a Range from 00:00:00:00 - 00:00:00:00 when there is overlap. Options inherit_rate : Which side to inherit the framerate from in mixed-rate calculations. If false , this function will raise if a 's rate does not match b 's rate. Default: false . inherit_out_type : Which side to inherit the out type from when a.out_type does not match b.out_type . If false , this function will raise if a 's rate does not match b 's rate. Default: false . Examples iex&gt; a_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Framestamp . with_frames! ( &quot;01:50:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;02:30:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; result = Range . separation! ( a , b ) iex&gt; inspect ( result ) &quot;&lt;00:00:00:00 - -00:00:00:01 :inclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.Range.html#separation!/3","title":"Vtc.Framestamp.Range.separation!/3","type":"function"},{"doc":"Returns a range with an :in value of stamp_in and a duration of duration . duration may be a Framestamp value for any value that implements the Frames protocol. Returns an error if duration is less than 0 seconds or if stamp_in and stamp_out do not have the same rate . Examples iex&gt; stamp_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; duration = Framestamp . with_frames! ( &quot;00:30:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . with_duration ( stamp_in , duration ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 01:30:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;}&quot; Using a timecode string as b : iex&gt; stamp_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . with_duration ( stamp_in , &quot;00:30:00:00&quot; ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 01:30:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;}&quot; Making a range with an inclusive out: iex&gt; stamp_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . with_duration ( stamp_in , &quot;00:30:00:00&quot; , out_type : :inclusive ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 01:29:59:23 :inclusive &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"Vtc.Framestamp.Range.html#with_duration/3","title":"Vtc.Framestamp.Range.with_duration/3","type":"function"},{"doc":"As with_duration/3, but raises on error.","ref":"Vtc.Framestamp.Range.html#with_duration!/3","title":"Vtc.Framestamp.Range.with_duration!/3","type":"function"},{"doc":"Adjusts range to have an exclusive out framestamp. Examples iex&gt; stamp_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; range = Range . new! ( stamp_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; result = Range . with_exclusive_out ( range ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:00 - 02:00:00:01 :exclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.Range.html#with_exclusive_out/1","title":"Vtc.Framestamp.Range.with_exclusive_out/1","type":"function"},{"doc":"Adjusts range to have an inclusive out framestamp. Examples iex&gt; stamp_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; range = Range . new! ( stamp_in , &quot;02:00:00:00&quot; ) iex&gt; iex&gt; result = Range . with_inclusive_out ( range ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:00 - 01:59:59:23 :inclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Framestamp.Range.html#with_inclusive_out/1","title":"Vtc.Framestamp.Range.with_inclusive_out/1","type":"function"},{"doc":"Whether the end point should be treated as the Range's boundary (:exclusive), or its last element (:inclusive).","ref":"Vtc.Framestamp.Range.html#t:out_type/0","title":"Vtc.Framestamp.Range.out_type/0","type":"type"},{"doc":"Range struct type.","ref":"Vtc.Framestamp.Range.html#t:t/0","title":"Vtc.Framestamp.Range.t/0","type":"type"},{"doc":"Functions and types for working with physical film data.","ref":"Vtc.FilmFormat.html","title":"Vtc.FilmFormat","type":"module"},{"doc":"Perforations are the holes that run along the sides of a strip of film, and are used by the camera's sprocket to physically pull the film in place to be exposed. For more information, see this Wikipedia article . By default, returns the count in a 'logical' foot. Logical feet and 16mm 'Logical foot' means each time XX rolls over when annotated in the XX+YY format. There are 40 perfs in a foot of 16mm film, but when annotated as XX+YY , XX rolls over every 6 inches rather than every foot. Options physical? : Return the physical number of feet rather than the logical number.","ref":"Vtc.FilmFormat.html#perfs_per_foot/2","title":"Vtc.FilmFormat.perfs_per_foot/2","type":"function"},{"doc":"Perforation count in a single frame of film.","ref":"Vtc.FilmFormat.html#perfs_per_frame/1","title":"Vtc.FilmFormat.perfs_per_frame/1","type":"function"},{"doc":"Enum-like type of supported film formats for Vtc. ff35mm_4perf 35mm 4-perf film (16 frames per foot). ex: '5400+13'. What it is On physical film, each foot contains a certain number of frames. For 35mm, 4-perf film (the most common type on Hollywood movies), this number is 16 frames per foot. Feet-and-frames was often used in place of Keycode to quickly reference a frame in the edit. Where you see it For the most part, feet + frames has died out as a reference, because digital media is not measured in feet. The most common place it is still used is Studio Sound Departments. Many Sound Mixers and Designers intuitively think in feet + frames, and it is often burned into the reference picture for them. Telecine. Sound turnover reference picture. Sound turnover change lists. ff35mm_2perf What it is 35mm 2-perf film records 32 frames in a foot of film, instead of the usual 16. This creates a negative image with a wide aspect ratio using standard spherical lenses and consumes half the footage per minute running time as standard 35mm, while having a grain profile somewhat better than 16mm while not as good as standard 35mm. Where you see it 35mm 2-perf formats are uncommon though still find occasional use, the process is usually marketed as &quot;Techniscope&quot;, the original trademark for Technicolor Italia's 2-perf format. It was historically very common in the Italian film industry prior to digital filmmaking, and is used on some contemporary films to obtain a film look while keeping stock and processing costs down. 16mm What it is On 16mm film, there are forty frames of film in each foot, one perforation per frame. However, 16mm film is edge coded every six inches, with twenty frames per code, so the footage &quot;1+19&quot; is succeeded by &quot;2+0&quot;. Where you see it 16mm telecine, 16mm edge codes.","ref":"Vtc.FilmFormat.html#t:t/0","title":"Vtc.FilmFormat.t/0","type":"type"},{"doc":"Pre-defined framerates commonly found in the wild.","ref":"Vtc.Rates.html","title":"Vtc.Rates","type":"module"},{"doc":"23.98 NTSC, non-drop.","ref":"Vtc.Rates.html#f23_98/0","title":"Vtc.Rates.f23_98/0","type":"function"},{"doc":"24 fps.","ref":"Vtc.Rates.html#f24/0","title":"Vtc.Rates.f24/0","type":"function"},{"doc":"29.97 NTSC, drop-frame.","ref":"Vtc.Rates.html#f29_97_df/0","title":"Vtc.Rates.f29_97_df/0","type":"function"},{"doc":"29.97 NTSC, non-drop.","ref":"Vtc.Rates.html#f29_97_ndf/0","title":"Vtc.Rates.f29_97_ndf/0","type":"function"},{"doc":"30 fps.","ref":"Vtc.Rates.html#f30/0","title":"Vtc.Rates.f30/0","type":"function"},{"doc":"47.95 NTSC non-drop.","ref":"Vtc.Rates.html#f47_95/0","title":"Vtc.Rates.f47_95/0","type":"function"},{"doc":"48 fps.","ref":"Vtc.Rates.html#f48/0","title":"Vtc.Rates.f48/0","type":"function"},{"doc":"59.94 NTSC drop-frame.","ref":"Vtc.Rates.html#f59_94_df/0","title":"Vtc.Rates.f59_94_df/0","type":"function"},{"doc":"59.94 NTSC non-drop.","ref":"Vtc.Rates.html#f59_94_ndf/0","title":"Vtc.Rates.f59_94_ndf/0","type":"function"},{"doc":"60 fps.","ref":"Vtc.Rates.html#f60/0","title":"Vtc.Rates.f60/0","type":"function"},{"doc":"Holds the individual sections of a SMPTE timecode for formatting / manipulation. Struct Fields negative : Whether the timecode is less than 0. hours : Hours place value. minutes : Minutes place value. This is not the total minutes, but the minutes added to hours to get a final time. seconds : Seconds place value. As minutes, remainder value rather than total value. frames : Frames place value. As seconds, remainder value rather than total value.","ref":"Vtc.SMPTETimecode.Sections.html","title":"Vtc.SMPTETimecode.Sections","type":"module"},{"doc":"Struct type.","ref":"Vtc.SMPTETimecode.Sections.html#t:t/0","title":"Vtc.SMPTETimecode.Sections.t/0","type":"type"},{"doc":"Holds Feet+Frames information. Fields feet : The amount of film in Feet that would run through the camera in a given amount of time. feet : The number of frames left over after feet of film has run. film_format : The type of film this value represents. Default: :ff35mm_4perf . String Conversion FeetAndFrames can be converted into a string through the String.Chars.to_string/1 function. Examples iex&gt; alias Vtc.Source.Frames.FeetAndFrames iex&gt; iex&gt; String.Chars . to_string ( % FeetAndFrames { feet : 10 , frames : 4 } ) &quot;10+04&quot;","ref":"Vtc.Source.Frames.FeetAndFrames.html","title":"Vtc.Source.Frames.FeetAndFrames","type":"module"},{"doc":"Parses a FeetAndFrames value from a string.","ref":"Vtc.Source.Frames.FeetAndFrames.html#from_string/2","title":"Vtc.Source.Frames.FeetAndFrames.from_string/2","type":"function"},{"doc":"Parses a FeetAndFrames value from a string.","ref":"Vtc.Source.Frames.FeetAndFrames.html#from_string!/2","title":"Vtc.Source.Frames.FeetAndFrames.from_string!/2","type":"function"},{"doc":"Contains only a single field for wrapping the underlying string.","ref":"Vtc.Source.Frames.FeetAndFrames.html#t:t/0","title":"Vtc.Source.Frames.FeetAndFrames.t/0","type":"type"},{"doc":"Implementation of Frames for timecode string. See Vtc.Framestamp.smpte_timecode/2 for more information on this format. This struct is used as an input wrapper only, not as the general-purpose Premiere ticks unit. By default, this wrapper does not need to be used by callers, as the string implementation of the frames protocol calls this type's impl automatically. Only use this type if you do not wish for the parser to fall back to feet+frames parsing as well.","ref":"Vtc.Source.Frames.SMPTETimecodeStr.html","title":"Vtc.Source.Frames.SMPTETimecodeStr","type":"module"},{"doc":"Contains only a single field for wrapping the underlying string.","ref":"Vtc.Source.Frames.SMPTETimecodeStr.html#t:t/0","title":"Vtc.Source.Frames.SMPTETimecodeStr.t/0","type":"type"},{"doc":"Implements Seconds protocol for Premiere ticks. See Vtc.Framestamp.premiere_ticks/2 for more information on this unit. This struct is used as an input wrapper only, not as the general-purpose Premiere ticks unit.","ref":"Vtc.Source.Seconds.PremiereTicks.html","title":"Vtc.Source.Seconds.PremiereTicks","type":"module"},{"doc":"Returns the number of ticks in a second.","ref":"Vtc.Source.Seconds.PremiereTicks.html#per_second/0","title":"Vtc.Source.Seconds.PremiereTicks.per_second/0","type":"function"},{"doc":"Contains only a single field for wrapping the underlying integer.","ref":"Vtc.Source.Seconds.PremiereTicks.html#t:t/0","title":"Vtc.Source.Seconds.PremiereTicks.t/0","type":"type"},{"doc":"Implementation of Seconds for runtime strings. See Vtc.Framestamp.runtime/2 for more information on this format. By default, this wrapper does not need to be used by callers, as the string implementation of the Seconds protocol calls this type's impl automatically. Only use this type if you do not wish for the parser to fall back to other type parsing as well.","ref":"Vtc.Source.Seconds.RuntimeStr.html","title":"Vtc.Source.Seconds.RuntimeStr","type":"module"},{"doc":"Contains only a single field for wrapping the underlying string.","ref":"Vtc.Source.Seconds.RuntimeStr.html#t:t/0","title":"Vtc.Source.Seconds.RuntimeStr.t/0","type":"type"},{"doc":"Protocol which types can implement to be passed as the main value of Framestamp.with_frames/2 . Implementations Out of the box, this protocol is implemented for the following types: Integer String &amp; BitString timecode (&quot;01:00:00:00&quot;) integer (&quot;86400&quot;) Feet+Frames (&quot;5400+00&quot;) SMPTETimecodeStr FeetAndFrames","ref":"Vtc.Source.Frames.html","title":"Vtc.Source.Frames","type":"protocol"},{"doc":"Returns the value as a frame count. Arguments value : The source value. rate : The framerate of the framestamp being parsed. Returns A result tuple with an integer value representing the frame count on success.","ref":"Vtc.Source.Frames.html#frames/2","title":"Vtc.Source.Frames.frames/2","type":"function"},{"doc":"Result type of frames/2 .","ref":"Vtc.Source.Frames.html#t:result/0","title":"Vtc.Source.Frames.result/0","type":"type"},{"doc":"","ref":"Vtc.Source.Frames.html#t:t/0","title":"Vtc.Source.Frames.t/0","type":"type"},{"doc":"Protocol which types can implement to be passed as the main value of Framestamp.with_seconds/3 . Implementations Out of the box, this protocol is implemented for the following types: Integer Float Ratio String runtime (&quot;01:00:00.0&quot;) decimal (&quot;3600.0&quot;) Vtc.Source.Seconds.RuntimeStr Vtc.Source.Seconds.PremiereTicks","ref":"Vtc.Source.Seconds.html","title":"Vtc.Source.Seconds","type":"protocol"},{"doc":"Returns the value as a rational, real-world seconds value. Arguments value : The source value. rate : The framerate of the framestamp being parsed. Returns A result tuple with a rational representation of the seconds value using Ratio on success.","ref":"Vtc.Source.Seconds.html#seconds/2","title":"Vtc.Source.Seconds.seconds/2","type":"function"},{"doc":"Result type of seconds/2 .","ref":"Vtc.Source.Seconds.html#t:result/0","title":"Vtc.Source.Seconds.result/0","type":"type"},{"doc":"","ref":"Vtc.Source.Seconds.html#t:t/0","title":"Vtc.Source.Seconds.t/0","type":"type"},{"doc":"Top-level migrations for creating all Vtc ecto types.","ref":"Vtc.Ecto.Postgres.Migrations.html","title":"Vtc.Ecto.Postgres.Migrations","type":"module"},{"doc":"Runs all migrations. Safe to run multiple times when updates are required. Migrations are run for: PgRational . PgFramerate . PgFramestamp . PgFramestamp.Range . All migrations implement both up and down functionality, and support rollbacks out of the box. Options pg_rational_opts : Options to pass to PgRational.Migrations.create_all/0 . pg_framerate_opts : Options to pass to PgFramerate.Migrations.create_all/0 . pg_framestamp_opts : Options to pass to PgFramestamp.Migrations.create_all/0 . pg_framestamp_range_opts : Options to pass to PgFramestamp.Rage.Migrations.create_all/0 . Required Permissions To add the framestamp_range canonical , function, we must directly add it to the framestamp_range type in the pg_catalog table. In most databases, this will require elevated permissions. See the PgFramestamp.Range.Migrations.inject_canonical_function/0 for more information on why this is required. You can choose to skip this step if you wish by setting the inject_canonical? op to false, but operations that require discreet nudging of in-and-out points will not return correct results, and ranges with different upper/lower bound types will not be comparable.","ref":"Vtc.Ecto.Postgres.Migrations.html#migrate/1","title":"Vtc.Ecto.Postgres.Migrations.migrate/1","type":"function"},{"doc":"Defines a composite type for storing rational values as a PgRational + list of tags. These values are cast to Framerate structs for use in application code. The composite types are defined as follows: CREATE TYPE framerate_tags AS ENUM ( &quot;drop&quot;, &quot;non_drop&quot; ) CREATE TYPE framerate as ( playback rational, tags framerate_tags[] ) framerate_tags is designed as such to guarantee forwards-compatibility with future support for features like interlaced timecode. Framerate values can be cast in SQL expressions like so: SELECT ((24000, 1001), '{non_drop}')::framerate Framerate tags The following values are valid tags: drop : Indicates NTSC, drop-frame timecode non_drop : Indicated NTSC, non-drop timecode Field migrations You can create framerate fields during a migration like so: alias Vtc.Framerate create table ( &quot;rationals&quot; ) do add ( :a , Framerate . type ( ) ) add ( :b , Framerate . type ( ) ) end Framerate re-exports the Ecto.Type implementation of this module, and can be used any place this module would be used. Schema fields Then in your schema module: defmodule MyApp.Framerates do @moduledoc false use Ecto.Schema alias Vtc.Framerate @type t ( ) :: % __MODULE__ { a : Framerate . t ( ) , b : Framerate . t ( ) } schema &quot;rationals_01&quot; do field ( :a , Framerate ) field ( :b , Framerate ) end Changesets With the above setup, changesets should just work: def changeset ( schema , attrs ) do schema |&gt; Changeset . cast ( attrs , [ :a , :b ] ) |&gt; Changeset . validate_required ( [ :a , :b ] ) end Framerate values can be cast from the following values in changesets: Framerate structs. Maps with the following format: { &quot;playback&quot;: [24000, 1001], &quot;ntsc&quot;: &quot;non_drop&quot; } Where playback is a value supported by PgRational casting and ntsc can be null , &quot;drop&quot; or &quot;non_drop&quot; . Fragments Framerate values must be explicitly cast using type/2 : framerate = Rates . f23_98 ( ) query = Query . from ( f in fragment ( &quot;SELECT ? as r&quot; , type ( ^ framerate , Framerate ) ) , select : f . r )","ref":"Vtc.Ecto.Postgres.PgFramerate.html","title":"Vtc.Ecto.Postgres.PgFramerate","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Vtc.Ecto.Postgres.PgFramerate.html#embed_as/1","title":"Vtc.Ecto.Postgres.PgFramerate.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Vtc.Ecto.Postgres.PgFramerate.html#equal?/2","title":"Vtc.Ecto.Postgres.PgFramerate.equal?/2","type":"function"},{"doc":"The database type for PgFramerate . Can be used in migrations as the fields type.","ref":"Vtc.Ecto.Postgres.PgFramerate.html#type/0","title":"Vtc.Ecto.Postgres.PgFramerate.type/0","type":"function"},{"doc":"Type of the raw composite value that will be sent to / received from the database.","ref":"Vtc.Ecto.Postgres.PgFramerate.html#t:db_record/0","title":"Vtc.Ecto.Postgres.PgFramerate.db_record/0","type":"type"},{"doc":"Migrations for adding framerate types, functions and constraints to a Postgres database.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations","type":"module"},{"doc":"Adds raw SQL queries to a migration for creating the database types, associated functions, casts, operators, and operator families. This migration included all migrations under the Pg Types , Pg Operators , Pg Functions , and Pg Private Functions , headings. Safe to run multiple times when new functionality is added in updates to this library. Existing values will be skipped. Individual migration functions return raw sql commands in an {up_command, down_command} tuple. Options include : A list of migration functions to include. If not set, all sub-migrations will be included. exclude : A list of migration functions to exclude. If not set, no sub-migrations will be excluded. Types Created Calling this macro creates the following type definitions: CREATE TYPE framerate_tags AS ENUM ( 'drop', 'non_drop' ); CREATE TYPE framerate AS ( playback rational, tags framerate_tags[] ); Schemas Created Up to two schemas are created as detailed by the Configuring Database Objects section below. Configuring Database Objects To change where supporting functions are created, add the following to your Repo configuration: config :vtc , Vtc.Test.Support.Repo , adapter : Ecto.Adapters.Postgres , ... vtc : [ framerate : [ functions_schema : :framerate , functions_prefix : &quot;framerate&quot; ] ] Option definitions are as follows: functions_schema : The postgres schema to store framerate-related custom functions. functions_prefix : A prefix to add before all functions. Defaults to &quot;framestamp&quot; for any function created in the :public schema, and &quot;&quot; otherwise. Private Functions Some custom function names are prefaced with __private__ . These functions should not be called by end-users, as they are not subject to any API stability guarantees. Examples defmodule MyMigration do use Ecto.Migration alias Vtc.Ecto.Postgres.PgFramerate require PgFramerate.Migrations def change do PgFramerate.Migrations . create_all ( ) end end","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#create_all/1","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.create_all/1","type":"function"},{"doc":"Creates basic constraints for a PgFramerate / Framerate database field. Arguments table : The table to make the constraint on. field : The name of the field being validated. Options check_value : The target value to check. If not set, table.field will be used. create_positive? : boolean Add {field}_positive constraint (see below). Default: true . create_ntsc_tags? : boolean Add {field}_ntsc_tags constraint (see below). Default: true . create_ntsc_valid? : boolean Add {field})_ntsc_valid constraint (see below). Default: true . create_ntsc_drop_valid? : boolean Add {field})_ntsc_drop_valid constraint (see below). Default: true . Constraints created: {field}_positive : Checks that the playback speed is positive. {field}_ntsc_tags : Checks that both drop and non_drop are not set at the same time. {field}_ntsc_valid : Checks that NTSC framerates are mathematically sound, i.e., that the rate is equal to (round(rate.playback) * 1000) / 1001 . {field}_ntsc_drop_valid : Checks that NTSC, drop-frame framerates are valid, i.e, are cleanly divisible by 30_000/1001 . Examples create table ( &quot;my_table&quot; , primary_key : false ) do add ( :id , :uuid , primary_key : true , null : false ) add ( :a , Framerate . type ( ) ) add ( :b , Framerate . type ( ) ) end PgRational . migration_add_field_constraints ( :my_table , :a ) PgRational . migration_add_field_constraints ( :my_table , :b )","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#create_constraints/3","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.create_constraints/3","type":"function"},{"doc":"Creates framerate.is_ntsc(rat) function that returns true if the framerate is an NTSC drop or non-drop rate.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#create_func_is_ntsc/0","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.create_func_is_ntsc/0","type":"function"},{"doc":"Creates framerate.__private__strict_eq(a, b) that backs the === operator.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#create_func_strict_eq/0","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.create_func_strict_eq/0","type":"function"},{"doc":"Creates framerate.__private__strict_eq(a, b) that backs the === operator.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#create_func_strict_neq/0","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.create_func_strict_neq/0","type":"function"},{"doc":"Creates function schema as described by the Configuring Database Objects section above.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#create_function_schemas/0","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.create_function_schemas/0","type":"function"},{"doc":"Creates a custom :framerate, :framerate === operator that returns true if both the playback rate AND tags of a framerate are equal.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#create_op_strict_eq/0","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.create_op_strict_eq/0","type":"function"},{"doc":"Creates a custom :framerate, :framerate === operator that returns true if both the playback rate AND tags of a framerate are equal.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#create_op_strict_neq/0","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.create_op_strict_neq/0","type":"function"},{"doc":"Adds framerate composite type.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#create_type_framerate/0","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.create_type_framerate/0","type":"function"},{"doc":"Adds framerate_tgs enum type.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#create_type_framerate_tags/0","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.create_type_framerate_tags/0","type":"function"},{"doc":"Returns the config-qualified name of the function for this type.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#function/2","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.function/2","type":"function"},{"doc":"Opts for create_constraints/3 .","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#t:constraint_opt/0","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.constraint_opt/0","type":"type"},{"doc":"Indicates returned string is an SQL command.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#t:raw_sql/0","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.raw_sql/0","type":"type"},{"doc":"SQL value that can be passed as an atom or a string.","ref":"Vtc.Ecto.Postgres.PgFramerate.Migrations.html#t:sql_value/0","title":"Vtc.Ecto.Postgres.PgFramerate.Migrations.sql_value/0","type":"type"},{"doc":"Defines a composite type for storing rational values as a PgRational real-world playback seconds, PgFramerate pair. These values are cast to Framestamp structs for use in application code. The composite types is defined as follows: CREATE TYPE framestamp AS ( __seconds_n bigint, __seconds_d bigint, __rate_n bigint, __rate_d bigint, __rate_tags framerate_tags[] ); Field Access framestamp's inner fields are considered semi-private to end-users. For working with the seconds / rate values, see create_func_seconds/0 , create_func_rate/0 , which create Postgres functions to act as getter functions for working with inner framestamp data. SELECT (18018, 5, 24000, 1001, '{non_drop}')::framestamp Field migrations You can create framerate fields during a migration like so: alias Vtc.Framestamp create table ( &quot;events&quot; ) do add ( :in , Framestamp . type ( ) ) add ( :out , Framestamp . type ( ) ) end Framestamp re-exports the Ecto.Type implementation of this module, and can be used any place this module would be used. Schema fields Then in your schema module: defmodule MyApp.Event do @moduledoc false use Ecto.Schema alias Vtc.Framestamp @type t ( ) :: % __MODULE__ { in : Framestamp . t ( ) , out : Framestamp . t ( ) } schema &quot;events&quot; do field ( :in , Framestamp ) field ( :out , Framestamp ) end Changesets With the above setup, changesets should just work: def changeset ( schema , attrs ) do schema |&gt; Changeset . cast ( attrs , [ :in , :out ] ) |&gt; Changeset . validate_required ( [ :in , :out ] ) end Framerate values can be cast from the following values in changesets: Framestamp structs. Maps with the following format: { &quot;smpte_timecode&quot;: &quot;01:00:00:00&quot;, &quot;rate&quot;: { &quot;playback&quot;: [24000, 1001], &quot;ntsc&quot;: &quot;non_drop&quot; } } Where smpte_timecode is properly formatted SMPTE timecode string and playback is a map value supported by PgFramerate changeset casts. Fragments Framestamp values must be explicitly cast using type/2 : framestamp = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) query = Query . from ( f in fragment ( &quot;SELECT ? as r&quot; , type ( ^ framestamp , Framestamp ) ) , select : f . r )","ref":"Vtc.Ecto.Postgres.PgFramestamp.html","title":"Vtc.Ecto.Postgres.PgFramestamp","type":"module"},{"doc":"The database type for PgFramerate . Can be used in migrations as the fields type.","ref":"Vtc.Ecto.Postgres.PgFramestamp.html#cast/1","title":"Vtc.Ecto.Postgres.PgFramestamp.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Vtc.Ecto.Postgres.PgFramestamp.html#embed_as/1","title":"Vtc.Ecto.Postgres.PgFramestamp.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Vtc.Ecto.Postgres.PgFramestamp.html#equal?/2","title":"Vtc.Ecto.Postgres.PgFramestamp.equal?/2","type":"function"},{"doc":"The database type for PgFramestamp . Can be used in migrations as the fields type.","ref":"Vtc.Ecto.Postgres.PgFramestamp.html#type/0","title":"Vtc.Ecto.Postgres.PgFramestamp.type/0","type":"function"},{"doc":"Adds all constraints created by PgFramestamp.Migrations.create_constraints/3 to changeset. Arguments changeset : The changeset being validated. field : The field who's constraints are being checked. Options Pass the same options that were passed to PgFramestamp.Migrations.create_constraints/3","ref":"Vtc.Ecto.Postgres.PgFramestamp.html#validate_constraints/3","title":"Vtc.Ecto.Postgres.PgFramestamp.validate_constraints/3","type":"function"},{"doc":"Type of the raw composite value that will be sent to / received from the database.","ref":"Vtc.Ecto.Postgres.PgFramestamp.html#t:db_record/0","title":"Vtc.Ecto.Postgres.PgFramestamp.db_record/0","type":"type"},{"doc":"Migrations for adding framestamp types, functions and constraints to a Postgres database.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations","type":"module"},{"doc":"Adds raw SQL queries to a migration for creating the database types, associated functions, casts, operators, and operator families. This migration includes all migrations under the Pg Types , Pg Operators , Pg Operator Classes , Pg Functions , and Pg Private Functions , headings. Safe to run multiple times when new functionality is added in updates to this library. Existing values will be skipped. Individual migration functions return raw sql commands in an {up_command, down_command} tuple. Options include : A list of migration functions to include. If not set, all sub-migrations will be included. exclude : A list of migration functions to exclude. If not set, no sub-migrations will be excluded. Types Created Calling this macro creates the following type definitions: CREATE TYPE framestamp AS ( __seconds_n bigint, __seconds_d bigint, __rate_n bigint, __rate_d bigint, __rate_tags framerate_tags[] ); Field Access framestamp's inner fields are considered semi-private to end-users. For working with the seconds / rate values, see create_func_seconds/0 and create_func_rate/0 , which create Postgres functions to act as getter functions for working with inner framestamp data. Schemas Created Up to two schemas are created as detailed by the Configuring Database Objects section below. Configuring Database Objects To change where supporting functions are created, add the following to your Repo configuration: config :vtc , Vtc.Test.Support.Repo , adapter : Ecto.Adapters.Postgres , ... vtc : [ framestamp : [ functions_schema : :framestamp , functions_prefix : &quot;framestamp&quot; ] ] Option definitions are as follows: functions_schema : The postgres schema to store framestamp-related custom functions. functions_prefix : A prefix to add before all functions. Defaults to &quot;framestamp&quot; for any function created in the :public schema, and &quot;&quot; otherwise. Private Functions Some custom function names are prefaced with __private__ . These functions should not be called by end-users, as they are not subject to any API stability guarantees. Examples defmodule MyMigration do use Ecto.Migration alias Vtc.Ecto.Postgres.PgFramestamp require PgFramestamp.Migrations def change do PgFramestamp.Migrations . create_all ( ) end end","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_all/1","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_all/1","type":"function"},{"doc":"Creates basic constraints for a PgFramestamp / Framestamp database field. Options create_seconds_divisible_by_rate? : If true, creates {field_name}_seconds_divisible_by_rate constraint (see below). Default: true . framerate_opts : Opts for framerate constraints. See PgFramerate.Migrations.create_constraints/3 Constraints created: {field}_rate_positive : Checks that the playback speed is positive. {field}_rate_ntsc_tags : Checks that both drop and non_drop are not set at the same time. {field}_rate_ntsc_valid : Checks that NTSC framerates are mathematically sound, i.e., that the rate is equal to (round(rate.playback) * 1000) / 1001 . {field}_rate_ntsc_drop_valid : Checks that NTSC, drop-frame framerates are valid, i.e, are cleanly divisible by 30_000/1001 . {field_name}_seconds_divisible_by_rate : Checks that the seconds value of the framestamp is cleanly divisible by the rate.playback value. Examples create table ( &quot;my_table&quot; , primary_key : false ) do add ( :id , :uuid , primary_key : true , null : false ) add ( :a , Framestamp . type ( ) ) add ( :b , Framestamp . type ( ) ) end PgRational . migration_add_field_constraints ( :my_table , :a ) PgRational . migration_add_field_constraints ( :my_table , :b )","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_constraints/3","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_constraints/3","type":"function"},{"doc":"Returns the absolute value of the framestamp.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_abs/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_abs/0","type":"function"},{"doc":"Creates framestamp.__private__add(a, b) that backs the + operator. Adds a to b . raises : data_exception if a and b do not have the same framerate.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_add/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_add/0","type":"function"},{"doc":"Creates framestamp.__private__add_inherit_left(a, b) that backs the @+ operator. Adds a to b . If a and b do not have the same framerate, result will inherit a 's rate and round seconds to the nearest whole-frame.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_add_inherit_left/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_add_inherit_left/0","type":"function"},{"doc":"Creates framestamp.__private__add_inherit_right(a, b) that backs the +@ operator. Adds a to b . If a and b do not have the same framerate, result will inherit b 's rate and round seconds to the nearest whole-frame.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_add_inherit_right/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_add_inherit_right/0","type":"function"},{"doc":"Creates framestamp.__private__cmp(a, b) used in the PgTimecode b-tree operator class.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_cmp/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_cmp/0","type":"function"},{"doc":"Creates framestamp.__private__div(:framestamp, :rational) that backs the / operator. Just like Framestamp.div/3 , a 's the internal seconds field will be rounded to the nearest whole-frame to ensure data integrity. Unlike Framestamp.div/3 , the result is rounded to the closest frame, rather than truncating ala integer division.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_div_rational/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_div_rational/0","type":"function"},{"doc":"framestamp.__private__eq(framestamp, framestamp) Backs the = operator.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_eq/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_eq/0","type":"function"},{"doc":"Creates DIV(:framestamp, :rational) that returns a floored :framestamp to match Postgres' DIV(real, real) behavior. Just like Framestamp.div/3 , this operation is done on the frame count representation of the Framestamp, which is then used as the basis of a new framestamp.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_floor_div_rational/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_floor_div_rational/0","type":"function"},{"doc":"Converts framestamp to a frame number by the frame's index in the timecode stream, with 0 as SMPTE midnight. Equivalent to Framestamp.frames/2 with :round set to trunc .","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_frames/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_frames/0","type":"function"},{"doc":"Creates framestamp.__private__gt(a, b) that backs the &gt; operator.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_gt/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_gt/0","type":"function"},{"doc":"Creates framestamp.__private__gte(a, b) that backs the &gt;= operator.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_gte/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_gte/0","type":"function"},{"doc":"Creates framestamp.__private__lt(a, b) that backs the &lt; operator.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_lt/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_lt/0","type":"function"},{"doc":"Creates framestamp.__private__lte(a, b) that backs the &lt;= operator.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_lte/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_lte/0","type":"function"},{"doc":"Creates framestamp.__private__minus(value) that backs unary - operator. Flips the sign of value . Equivalent to value * -1 .","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_minus/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_minus/0","type":"function"},{"doc":"Creates framestamp.__private__modulo(:framestamp, :rational) that backs the % operator. Just like Framestamp.rem/3 , this operation is done on the frame count representation of the Framestamp, which is then used as the basis of a new framestamp.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_modulo_rational/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_modulo_rational/0","type":"function"},{"doc":"Creates framestamp.__private__mult(:framestamp, :rational) that backs the * operator. Just like Framestamp.mult/3 , a 's the internal seconds field will be rounded to the nearest whole-frame to ensure data integrity.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_mult_rational/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_mult_rational/0","type":"function"},{"doc":"Creates framestamp.__private__neq(a, b) that backs the &lt;&gt; operator.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_neq/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_neq/0","type":"function"},{"doc":"Returns the internal framerate value.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_rate/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_rate/0","type":"function"},{"doc":"Returns the internal real-world seconds value as a rational.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_seconds/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_seconds/0","type":"function"},{"doc":"Creates framestamp.__private__simplify(bigint. bigint) function that simplifies a rational value based on two ints. Used at the end of every rational operation to avoid overflows.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_simplify/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_simplify/0","type":"function"},{"doc":"Creates framestamp.__private__strict_eq(a, b) that backs the === operator. Checks that both the seconds value AND the framerate are equivalent.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_strict_eq/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_strict_eq/0","type":"function"},{"doc":"Creates framestamp.__private__strict_neq(a, b) that backs the !=== operator. Checks if either the seconds value OR the framerate are not equivalent.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_strict_neq/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_strict_neq/0","type":"function"},{"doc":"framestamp.__private__sub(a, b) that backs the - operator. Subtracts a from b . raises : data_exception if a and b do not have the same framerate.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_sub/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_sub/0","type":"function"},{"doc":"Creates framestamp.__private__sub_inherit_left(a, b) that backs the @- operator. Subtracts a from b . If a and b do not have the same framerate, result will inherit a 's rate and round seconds to the nearest whole-frame.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_sub_inherit_left/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_sub_inherit_left/0","type":"function"},{"doc":"Creates framestamp.__private__sub_inherit_right(a, b) that backs the -@ operator. Subtracts a from b . If a and b do not have the same framerate, result will inherit b 's rate and round seconds to the nearest whole-frame.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_sub_inherit_right/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_sub_inherit_right/0","type":"function"},{"doc":"Creates framestamp.with_frames(frames, rate) Constructs a framestamp for the given frame count. When passed to framestamp.frames/1 , the returned value will yield frames .","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_with_frames/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_with_frames/0","type":"function"},{"doc":"Creates framestamp.with_seconds(seconds, rate) Constructs a framestamp for the given real-world seconds , rounded to the nearest whole-frame based on rate . When passed to framestamp.seconds/1 , the returned value will yield the rounded seconds .","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_func_with_seconds/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_func_with_seconds/0","type":"function"},{"doc":"Creates function schema as described by the Configuring Database Objects section above.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_function_schemas/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_function_schemas/0","type":"function"},{"doc":"Creates a custom unary :framestamp @ operator. Returns the absolute value of the framestamp.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_abs/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_abs/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp + operator. Adds a to b . raises : data_exception if a and b do not have the same framerate.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_add/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_add/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp @+ operator. Adds a to b . If a and b do not have the same framerate, result will inherit a 's rate and round seconds to the nearest whole-frame.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_add_inherit_left/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_add_inherit_left/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp +@ operator. Adds a to b . If a and b do not have the same framerate, result will inherit b 's rate and round seconds to the nearest whole-frame.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_add_inherit_right/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_add_inherit_right/0","type":"function"},{"doc":"Creates a B-tree operator class to support indexing on comparison operations.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_class_btree/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_class_btree/0","type":"function"},{"doc":"Creates a custom :framestamp, :rational / operator. Just like Framestamp.div/3 , a 's the internal seconds value will be rounded to the nearest whole-frame to ensure data integrity. Unlike Framestamp.div/3 , the result is rounded to the closest frame, rather than truncating ala integer division.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_div_rational/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_div_rational/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp = operator that returns true if the real-world seconds values for both framestamps are equal.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_eq/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_eq/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp &gt; operator.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_gt/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_gt/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp &gt;= operator.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_gte/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_gte/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp &lt; operator.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_lt/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_lt/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp &lt;= operator.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_lte/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_lte/0","type":"function"},{"doc":"Creates a custom unary :framestamp - operator. Flips the sign of value . Equivalent to value * -1 .","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_minus/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_minus/0","type":"function"},{"doc":"Creates a custom :framestamp, :rational % operator. Just like Framestamp.rem/3 , this operation is done on the frame count representation of the Framestamp, which is then used as the basis of a new framestamp.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_modulo_rational/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_modulo_rational/0","type":"function"},{"doc":"Creates a custom :framestamp, :rational * operator. Just like Framestamp.mult/3 , a 's the internal seconds value will be rounded to the nearest whole-frame to ensure data integrity.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_mult_rational/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_mult_rational/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp &lt;&gt; operator that returns true if the real-world seconds values for both framestamps are not equal.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_neq/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_neq/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp === operator that returns true if both the real-world seconds values and the framerates for both framestamps are equal.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_strict_eq/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_strict_eq/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp !=== operator that returns true if a and b do not have the same real-world-seconds, framerate playback, or framerate tags.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_strict_neq/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_strict_neq/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp - operator. Subtracts a from b . raises : data_exception if a and b do not have the same framerate.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_sub/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_sub/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp @- operator. Subtracts a from b . If a and b do not have the same framerate, result will inherit a 's rate and round seconds to the nearest whole-frame.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_sub_inherit_left/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_sub_inherit_left/0","type":"function"},{"doc":"Creates a custom :framestamp, :framestamp -@ operator. Subtracts a from b . If a and b do not have the same framerate, result will inherit b 's rate and round seconds to the nearest whole-frame.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_op_sub_inherit_right/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_op_sub_inherit_right/0","type":"function"},{"doc":"Adds framestamp composite type. Fields __seconds_n : bigint . Numerator of the real-world seconds this frame occurred at, as a rational value. __seconds_d : bigint . Denominator of the real-world seconds this frame occurred at, as a rational value. __rate_n : bigint . Numerator of the real-world playback speed of this frame's media stream. __rate_d : bigint . Denominator of the real-world playback speed of this frame's media stream. __rate_tags[] : Information about the format this framestamp was parsed from, to support lossless round-trips.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#create_type_framestamp/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.create_type_framestamp/0","type":"function"},{"doc":"Returns the config-qualified name of the function for this type.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#function/2","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.function/2","type":"function"},{"doc":"Option types for create_constraints/2 .","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#t:constraint_opt/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.constraint_opt/0","type":"type"},{"doc":"Indicates returned string is an SQL command.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#t:raw_sql/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.raw_sql/0","type":"type"},{"doc":"SQL value that can be passed as an atom or a string.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.html#t:sql_value/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Migrations.sql_value/0","type":"type"},{"doc":"Defines a custom Range type for dealing with Framestamp ranges. The new range types are defined as follows: CREATE TYPE framestamp_range AS RANGE ( subtype = framestamp, subtype_diff = framestamp_range_private.subtype_diff canonical = framestamp_range_private.canonical ); Framestamp ranges can be created in SQL expressions like so: SELECT framestamp_range(stamp_1, stamp_2, '[)') Framestamp fastranges can be created in SQL expressions like so: SELECT framestamp_fastrange(stamp_1, stamp_2) Indexing framestamp_range is currently VERY slow when using a GiST index, consider using a framestamp_fastrange instead. Canonicalization Postgres framestamp_range values are ALWAYS coerced to exclusive out ranges. That means that even if a Framestamp.Range has :out_type set to :inclusive when it is sent to the database, it will come back from the database with :out_type set to :exclusive , and the :out field will be adjusted accordingly. Further, when a Range operation, like a union, would result in an in-and-out point with different framerates, the higher rate will always be selected. This unlike the application behavior of Vtc.Framestamp.Range , which always inherits the rate of the value that appears on the left side. This behavior may be updated to match Vtc's application behavior in the future. Framestamp Fast Range In addition to framestamp_range , a framestamp_fastrange type is defined as well: CREATE TYPE framestamp_fastrange AS RANGE ( subtype = double precision, subtype_diff = float8mi ); Fast ranges are meant to support GiST indexing, as in most cases, framestamp_range will be VERY slow to index. Frame-accurate Unlike framestamp_range , framestamp_fastrange is NOT frame-accurate and should not be used where frame-accuracy is desired or required. Field migrations You can create framestamp_range fields during a migration like so: alias Vtc.Framerate create table ( &quot;framestamp_ranges&quot; ) do add ( :a , Framestamp.Range . type ( ) ) add ( :b , Framestamp.Range . type ( ) ) end Framestamp.Range re-exports the Ecto.Type implementation of this module, and can be used any place this module would be used. Schema fields Then in your schema module: defmodule MyApp.FramestampRanges do @moduledoc false use Ecto.Schema alias Vtc.Framestamp @type t ( ) :: % __MODULE__ { a : Framestamp.Range . t ( ) , b : Framestamp.Range . t ( ) } schema &quot;rationals_01&quot; do field ( :a , Framestamp.Range ) field ( :b , Framestamp.Range ) end Changesets With the above setup, changesets should just work: def changeset ( schema , attrs ) do schema |&gt; Changeset . cast ( attrs , [ :a , :b ] ) |&gt; Changeset . validate_required ( [ :a , :b ] ) end Framestamp.Range values can be cast from the following values in changesets: Framerate structs. Fragments Framerate values must be explicitly cast using type/2 : stamp_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) stamp_out = Framestamp . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) stamp_range = Framestamp . new! ( stamp_in , stamp_out ) query = Query . from ( f in fragment ( &quot;SELECT ? as r&quot; , type ( ^ stamp_range , Framerate.Range ) ) , select : f . r )","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.html","title":"Vtc.Ecto.Postgres.PgFramestamp.Range","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.html#embed_as/1","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.html#equal?/2","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.equal?/2","type":"function"},{"doc":"The database type for PgFramerate . Can be used in migrations as the fields type.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.html#type/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.type/0","type":"function"},{"doc":"Type of the raw composite value that will be sent to / received from the database.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.html#t:db_record/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.db_record/0","type":"type"},{"doc":"Migrations for adding framestamp range types, functions and constraints to a Postgres database.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.html","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations","type":"module"},{"doc":"Adds raw SQL queries to a migration for creating the database types, associated functions, casts, operators, and operator families. This migration includes all migrations under the Pg Types , Pg Operator Classes , Pg Functions , and Pg Private Functions , headings. Safe to run multiple times when new functionality is added in updates to this library. Existing values will be skipped. Individual migration functions return raw sql commands in an {up_command, down_command} tuple. Options include : A list of migration functions to include. If not set, all sub-migrations will be included. exclude : A list of migration functions to exclude. If not set, no sub-migrations will be excluded. Required Permissions To add the framestamp_range canonical , function, we must directly add it to the framestamp_range type in the pg_catalog table. In most databases, this will require elevated permissions. See the inject_canonical_function/0 for more information on why this is required. You can choose to skip this step if you wish by setting the inject_canonical? op to false, but operations that require discreet nudging of in-and-out points will not return correct results, and ranges with different upper/lower bound types will not be comparable. Types Created Calling this macro creates the following type definitions: CREATE TYPE framestamp_range AS RANGE ( subtype = framestamp, subtype_diff = framestamp_range_private.subtype_diff canonical = framestamp_range_private.canonical ); CREATE TYPE framestamp_fastrange AS RANGE ( subtype = double precision, subtype_diff = float8mi ); Schemas Created Up to two schemas are created as detailed by the Configuring Database Objects section below. Configuring Database Objects To change where supporting functions are created, add the following to your Repo configuration: config :vtc , Vtc.Test.Support.Repo , adapter : Ecto.Adapters.Postgres , ... vtc : [ framestamp_range : [ functions_schema : :framestamp_range , functions_prefix : &quot;framestamp_range&quot; ] ] Option definitions are as follows: functions_schema : The postgres schema to store framestamp_range-related custom functions. functions_prefix : A prefix to add before all functions. Defaults to &quot;framestamp_range&quot; for any function created in the :public schema, and &quot;&quot; otherwise. Examples defmodule MyMigration do use Ecto.Migration alias Vtc.Ecto.Postgres.PgFramestamp require PgFramestamp.Migrations def change do PgFramestamp.Range.Migrations . create_all ( ) end end","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.html#create_all/1","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.create_all/1","type":"function"},{"doc":"Creates framestamp.__private__canonical(a, b, type) used by the range constructor to normalize ranges. Output ranges have an inclusive lower bound and an exclusive upper bound.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.html#create_func_canonical/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.create_func_canonical/0","type":"function"},{"doc":"Creates framestamp_fastrange(:framestamp_range) to construct fast ranges out of the slower framestamp_range type.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.html#create_func_framestamp_fastrange_from_range/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.create_func_framestamp_fastrange_from_range/0","type":"function"},{"doc":"Creates framestamp_fastrange(:framestamp, framestamp) to construct fast ranges out of framestamps.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.html#create_func_framestamp_fastrange_from_stamps/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.create_func_framestamp_fastrange_from_stamps/0","type":"function"},{"doc":"Creates framestamp.__private__subtype_diff(a, b) used by the range type for more efficient GiST indexes.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.html#create_func_subtype_diff/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.create_func_subtype_diff/0","type":"function"},{"doc":"Creates function schema as described by the Configuring Database Objects section above.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.html#create_function_schemas/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.create_function_schemas/0","type":"function"},{"doc":"Adds framestamp_fastrange RANGE type that uses double-precision floats under the hood.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.html#create_type_framestamp_fastrange/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.create_type_framestamp_fastrange/0","type":"function"},{"doc":"Adds framestamp_range RANGE type.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.html#create_type_framestamp_range/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.create_type_framestamp_range/0","type":"function"},{"doc":"There is a limitation with PL/pgSQL where shell-types cannot be used as either arguments OR return types. However, in the user-facing API flow, the canonical function must be created before the range type with a shell type, then passed to the range type upon construction. Further, ALTER TYPE does not work on range functions out-of-the gate, so we cannot add it later... through the public API. Instead this function edits the pg_catalog directly and we supply the function after-the-fact ourselves. Since this will all happen in a single transaction it should be functionally equivalent to creating it on the type as part of the initial call. Permissions In most databases, directly editing the pg_catalog will require elevated permissions.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.html#inject_canonical_function/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.inject_canonical_function/0","type":"function"},{"doc":"Indicates returned string is an SQL command.","ref":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.html#t:raw_sql/0","title":"Vtc.Ecto.Postgres.PgFramestamp.Range.Migrations.raw_sql/0","type":"type"},{"doc":"Defines a composite type for storing rational values as dual int64s. These values are cast to %Ratio{} structs for use in application code, provided by the Ratio library. The composite type is defined as follows: CREATE TYPE rational as ( numerator bigint, denominator bigint ) Rational values can be cast in SQL expressions like so: SELECT (1, 2)::rational See Vtc.Ecto.Postgres.PgRational.Migrations for more information on how to create rational and its supporting functions in your database. Field migrations You can create a field as a rational during a migration like so: create table ( &quot;rationals&quot; ) do add ( :a , PgRational . type ( ) ) add ( :b , PgRational . type ( ) ) end Schema fields Then in your schema module: defmodule MyApp.Rationals do @moduledoc false use Ecto.Schema alias Vtc.Ecto.Postgres.PgRational @type t ( ) :: % __MODULE__ { a : Ratio . t ( ) , b : Ratio . t ( ) } schema &quot;rationals_01&quot; do field ( :a , PgRational ) field ( :b , PgRational ) end ... notice that the schema field type is PgRational , but the type-spec field uses Ratio.t() , the type that our DB fields will be deserialized into. Changesets With the above setup, changesets should just work: def changeset ( schema , attrs ) do schema |&gt; Changeset . cast ( attrs , [ :a , :b ] ) |&gt; Changeset . validate_required ( [ :a , :b ] ) end Rational values can be cast from the following values in changesets: %Ratio{} structs. [numerator, denominator] integer arrays. Useful for non-text JSON values that can be set in a single field. Strings formatted as 'numerator/denominator' . Useful for casting from a JSON string.","ref":"Vtc.Ecto.Postgres.PgRational.html","title":"Vtc.Ecto.Postgres.PgRational","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Vtc.Ecto.Postgres.PgRational.html#embed_as/1","title":"Vtc.Ecto.Postgres.PgRational.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Vtc.Ecto.Postgres.PgRational.html#equal?/2","title":"Vtc.Ecto.Postgres.PgRational.equal?/2","type":"function"},{"doc":"The database type for PgRational . Can be used in migrations as the fields type.","ref":"Vtc.Ecto.Postgres.PgRational.html#type/0","title":"Vtc.Ecto.Postgres.PgRational.type/0","type":"function"},{"doc":"Type of the raw composite value that will be sent to / received from the database.","ref":"Vtc.Ecto.Postgres.PgRational.html#t:db_record/0","title":"Vtc.Ecto.Postgres.PgRational.db_record/0","type":"type"},{"doc":"Migrations for adding rational types, casts, functions and constraints to a Postgres database.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html","title":"Vtc.Ecto.Postgres.PgRational.Migrations","type":"module"},{"doc":"Adds raw SQL queries to a migration for creating the database types, associated functions, casts, operators, and operator families. This migration includes all migrations under the Pg Types , Pg Operators , Pg Operator Classes , Pg Functions , Pg Private Functions , headings, and Pg Casts Safe to run multiple times when new functionality is added in updates to this library. Existing values will be skipped. Individual migration functions return raw sql commands in an {up_command, down_command} tuple. Options include : A list of migration functions to include. If not set, all sub-migrations will be included. exclude : A list of migration functions to exclude. If not set, no sub-migrations will be excluded. Types Created Calling this macro creates the following type definitions: CREATE TYPE public.rational AS ( numerator bigint, denominator bigint ); Schemas Created Up to two schemas are created as detailed by the Configuring Database Objects section below. Configuring Database Objects To change where supporting functions are created, add the following to your Repo configuration: config :vtc , Vtc.Test.Support.Repo , adapter : Ecto.Adapters.Postgres , ... vtc : [ rational : [ functions_schema : :rational , functions_prefix : &quot;rational&quot; ] ] Option definitions are as follows: functions_schema : The postgres schema to store rational-related custom functions. functions_prefix : A prefix to add before all functions. Defaults to &quot;rational&quot; for any function created in the :public schema, and &quot;&quot; otherwise. Private Functions Some custom function names are prefaced with __private__ . These functions should not be called by end-users, as they are not subject to any API stability guarantees. Functions Created See PgFunctions section of these docs for details on native database functions created. Operators Created See PgOperators section of these docs for details on native database operators created. Casts Created See PgCasts section of these docs for details on native database operators created. Examples defmodule MyMigration do use Ecto.Migration alias Vtc.Ecto.Postgres.PgRational require PgRational.Migrations def change do PgRational.Migrations . create_all ( ) end end","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_all/1","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_all/1","type":"function"},{"doc":"Creates a native cast for: bigint AS rational","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_cast_bigint_to_rational/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_cast_bigint_to_rational/0","type":"function"},{"doc":"Creates a native cast for: rational AS double precision","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_cast_double_precision/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_cast_double_precision/0","type":"function"},{"doc":"Creates basic constraints for a PgRational database field. Constraints created: {field_name}_denominator_positive : Checks that the denominator of the field is positive. Examples create table ( &quot;rationals&quot; , primary_key : false ) do add ( :id , :uuid , primary_key : true , null : false ) add ( :a , PgRational . type ( ) ) add ( :b , PgRational . type ( ) ) end PgRational . migration_add_field_constraints ( :rationals , :a ) PgRational . migration_add_field_constraints ( :rationals , :b )","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_constraints/2","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_constraints/2","type":"function"},{"doc":"Creates ABS(rational) function that returns the absolute value of the rational value.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_abs/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_abs/0","type":"function"},{"doc":"Creates rational.__private__add(a, b) backing function for the + operator between two rationals.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_add/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_add/0","type":"function"},{"doc":"Creates a native CAST from bigint to rational .","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_cast_bigint_to_rational/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_cast_bigint_to_rational/0","type":"function"},{"doc":"Creates a native CAST from rational to double precision .","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_cast_to_double_precision/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_cast_to_double_precision/0","type":"function"},{"doc":"Creates rational.__private__cmp(a, b) that returns: 1 if a &gt; b 0 if a == b -1 if a &lt; b Used to back equality operators.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_cmp/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_cmp/0","type":"function"},{"doc":"Creates rational.__private__div(a, b) backing function for the / operator between two rationals.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_div/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_div/0","type":"function"},{"doc":"Creates rational.__private__eq(a, b) that backs the = operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_eq/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_eq/0","type":"function"},{"doc":"Creates FLOOR(rational) function that returns the rational input as a bigint , rounded towards zero, to match Postgres FLOOR(real) behavior.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_floor/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_floor/0","type":"function"},{"doc":"Creates DIV(a, b) function, which executed integer floor division on rational values. Just like DIV(real, real) , DIV(rational, rational) floors towards zero.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_floor_div/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_floor_div/0","type":"function"},{"doc":"Creates rational.__private__gt(a, b) that backs the &gt; operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_gt/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_gt/0","type":"function"},{"doc":"Creates rational.__private__gte(a, b) that backs the &gt;= operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_gte/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_gte/0","type":"function"},{"doc":"Creates rational.__private__lt(a, b) that backs the &lt; operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_lt/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_lt/0","type":"function"},{"doc":"Creates rational.__private__lte(a, b) that backs the &lt;= operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_lte/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_lte/0","type":"function"},{"doc":"Creates rational.minus(rat) function that flips the sign of the input value -- makes a positive value negative and a negative value positive.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_minus/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_minus/0","type":"function"},{"doc":"Creates rational.__private__modulo(a, b) backing function for the % operator between two rationals.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_modulo/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_modulo/0","type":"function"},{"doc":"Creates rational.__private__mult(a, b) backing function for the * operator between two rationals.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_mult/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_mult/0","type":"function"},{"doc":"Creates rational.__private__neq(a, b) that backs the &lt;&gt; operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_neq/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_neq/0","type":"function"},{"doc":"Creates ROUND(rational) function that returns the rational input, rounded to the nearest :bigint.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_round/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_round/0","type":"function"},{"doc":"Creates rational.__private__simplify(rat) function that simplifies a rational. Used at the end of every rational operation to avoid overflows.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_simplify/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_simplify/0","type":"function"},{"doc":"Creates rational.__private__sub(a, b) backing function for the - operator between two rationals.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_func_sub/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_func_sub/0","type":"function"},{"doc":"Creates function schema as described by the Configuring Database Objects section above.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_function_schemas/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_function_schemas/0","type":"function"},{"doc":"Creates a custom :rational, :rational + operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_add/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_add/0","type":"function"},{"doc":"Creates a B-tree operator class to support indexing on comparison operations.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_class_btree/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_class_btree/0","type":"function"},{"doc":"Creates a custom :rational, :rational / operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_div/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_div/0","type":"function"},{"doc":"Creates a custom :rational, :rational = operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_eq/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_eq/0","type":"function"},{"doc":"Creates a custom :rational, :rational &lt; operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_gt/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_gt/0","type":"function"},{"doc":"Creates a custom :rational, :rational &lt; operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_gte/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_gte/0","type":"function"},{"doc":"Creates a custom :rational, :rational &lt; operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_lt/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_lt/0","type":"function"},{"doc":"Creates a custom :rational, :rational &lt; operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_lte/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_lte/0","type":"function"},{"doc":"Creates a custom :rational, :rational % operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_modulo/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_modulo/0","type":"function"},{"doc":"Creates a custom :rational, :rational * operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_mult/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_mult/0","type":"function"},{"doc":"Creates a custom :rational, :rational &lt;&gt; operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_neq/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_neq/0","type":"function"},{"doc":"Creates a custom :rational, :rational - operator.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_op_sub/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_op_sub/0","type":"function"},{"doc":"Adds: rational composite type rationals schema rationals_helpers schema","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_type/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_type/0","type":"function"},{"doc":"Returns the config-qualified name of the function for this type.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#function/2","title":"Vtc.Ecto.Postgres.PgRational.Migrations.function/2","type":"function"},{"doc":"Indicates returned string is an SQL command.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#t:raw_sql/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.raw_sql/0","type":"type"},{"doc":"StreamData generators for use in tests that involve custom Ecto types. For use in property tests. This module is only available in :test and :dev envs.","ref":"Vtc.TestUtils.StreamDataVtc.html","title":"Vtc.TestUtils.StreamDataVtc","type":"module"},{"doc":"Yields Vtc.Framerates, always yields true-frame or NTSC; never a mixture of the two. Options type : The ntsc value all framerates should be generated with. Can be any of the following: :whole : All yielded framerates will be non-ntsc, whole-frame rates. Ex: 24/1 fps. :fractional : All yielded framerates will be a random non-drop rate. :non_drop : All yielded framerates will be NTSC, non-drop values. :drop : All yielded framerates will be NTSC, drop-frame values. A list of the above options may be passed and each value yielded from this generator will pick randomly from them. Defaults to [:whole, :fractional, :non_drop, :drop] Examples property &quot;prop test&quot; do check all ( framerate &lt;- StreamDataVtc . framerate ( ) ) do ... end end","ref":"Vtc.TestUtils.StreamDataVtc.html#framerate/1","title":"Vtc.TestUtils.StreamDataVtc.framerate/1","type":"function"},{"doc":"Yields Vtc.Framestamp values. Options non_negative? : Will only return values greater than or equal to 00:00:00:00 . rate : A framerate to use for this test. If one is not provided, a random one will be used. rate_opts : Opts that should be passed to framerate/1 when generating the framerate. Has no effect if rate is set. Examples property &quot;returns input of negate/1&quot; do check all ( positive &lt;- StreamDataVtc . framestamp ( non_negative? : true ) ) do negative = Framestamp . minus ( positive ) assert Framestamp . abs ( positive ) == Framestamp . abs ( negative ) end end","ref":"Vtc.TestUtils.StreamDataVtc.html#framestamp/1","title":"Vtc.TestUtils.StreamDataVtc.framestamp/1","type":"function"},{"doc":"Yields Vtc.Framestamp.Range values. Options rate_opts : The options to pass to the framerate/1 generator for this range. stamp_opts : The options to pass to the framestamp/1 generators for this range. filter_empty? : If true , filters 0-length ranges from the output. Default: false . Examples property &quot;returns input of negate/1&quot; do check all ( positive &lt;- StreamDataVtc . framestamp_range ( ) ) do ... end end","ref":"Vtc.TestUtils.StreamDataVtc.html#framestamp_range/1","title":"Vtc.TestUtils.StreamDataVtc.framestamp_range/1","type":"function"},{"doc":"Yields rational values as %Ratio{} structs. Options numerator : A static value to use for the numerator of all generated rationals. Default: nil. denominator : A static value to use for the denominator of all generated rationals. Default: nil. positive? : If true, only positive values (greater than 0) are generated. Default: false . Examples property &quot;prop test&quot; do check all ( fraction &lt;- StreamDataVtc . rational ( ) ) do ... end end","ref":"Vtc.TestUtils.StreamDataVtc.html#rational/1","title":"Vtc.TestUtils.StreamDataVtc.rational/1","type":"function"},{"doc":"Runs a test, but does not fail if the operation causes a drop-frame overflow exception to occur.","ref":"Vtc.TestUtils.StreamDataVtc.html#run_test_rescue_drop_overflow/1","title":"Vtc.TestUtils.StreamDataVtc.run_test_rescue_drop_overflow/1","type":"function"},{"doc":"Describes the opts that can be passed to framerate/1 .","ref":"Vtc.TestUtils.StreamDataVtc.html#t:framerate_opts/0","title":"Vtc.TestUtils.StreamDataVtc.framerate_opts/0","type":"type"},{"doc":"","ref":"Vtc.TestUtils.StreamDataVtc.html#t:framestamp_opts/0","title":"Vtc.TestUtils.StreamDataVtc.framestamp_opts/0","type":"type"},{"doc":"Exception returned when a framerate cannot be parsed. Struct Fields reason : The reason the error occurred. Failure Reasons The following values can appear in the :reason fields: :bad_drop_rate : Returned when the playback speed of a framerate with an ntsc value of :drop is not divisible by 3000/1001 (29.97), for more on why drop-frame framerates must be a multiple of 29.97, see: https://www.davidheidelberger.com/2010/06/10/drop-frame-timecode/ :invalid_ntsc : Returned when the ntsc value is not one of the allowed atom values. :unrecognized_format : Returned when a string value is not a recognized format. :imprecise - Returned when a float was passed with an NTSC value of nil. Without the ability to round to the nearest valid NTSC value, floats are not precise enough to build an arbitrary framerate.","ref":"Vtc.Framerate.ParseError.html","title":"Vtc.Framerate.ParseError","type":"exception"},{"doc":"Returns a message for the error reason.","ref":"Vtc.Framerate.ParseError.html#message/1","title":"Vtc.Framerate.ParseError.message/1","type":"function"},{"doc":"Type of ParseError","ref":"Vtc.Framerate.ParseError.html#t:t/0","title":"Vtc.Framerate.ParseError.t/0","type":"type"},{"doc":"Exception returned when mixed-rate arithmetic was attempted without specifying which side of the operation's rate should be inherited. Struct Fields left_rate : The rate that was found on the left side of the operation. right_rate : The rate that was found on the right side of the operation.","ref":"Vtc.Framestamp.MixedRateArithmeticError.html","title":"Vtc.Framestamp.MixedRateArithmeticError","type":"exception"},{"doc":"Returns a message for the error reason.","ref":"Vtc.Framestamp.MixedRateArithmeticError.html#message/1","title":"Vtc.Framestamp.MixedRateArithmeticError.message/1","type":"function"},{"doc":"Type of Framestamp.MixedRateError .","ref":"Vtc.Framestamp.MixedRateArithmeticError.html#t:t/0","title":"Vtc.Framestamp.MixedRateArithmeticError.t/0","type":"type"},{"doc":"Exception returned when there is an error parsing a Timecode value. Struct Fields reason : The reason the error occurred. Failure Reasons The following values can appear in the :reason fields: :unrecognized_format : Returned when a string value is not a recognized timecode, runtime, etc. format. :bad_drop_frames : Returned when parsing SMPTE, drop-frame timecode. Indicates that the 'frames' field represents a frame that should have been dropped.","ref":"Vtc.Framestamp.ParseError.html","title":"Vtc.Framestamp.ParseError","type":"exception"},{"doc":"Returns a message for the error reason.","ref":"Vtc.Framestamp.ParseError.html#message/1","title":"Vtc.Framestamp.ParseError.message/1","type":"function"},{"doc":"Type of Framestamp.ParseError .","ref":"Vtc.Framestamp.ParseError.html#t:t/0","title":"Vtc.Framestamp.ParseError.t/0","type":"type"},{"doc":"Exception returned when mixed-out-type arithmetic was attempted without specifying which side of the operation's out type should be inherited. Struct Fields left_out_type : The out type that was found on the left side of the operation. right_out_type : The out type that was found on the right side of the operation.","ref":"Vtc.Framestamp.Range.MixedOutTypeArithmeticError.html","title":"Vtc.Framestamp.Range.MixedOutTypeArithmeticError","type":"exception"},{"doc":"Returns a message for the error reason.","ref":"Vtc.Framestamp.Range.MixedOutTypeArithmeticError.html#message/1","title":"Vtc.Framestamp.Range.MixedOutTypeArithmeticError.message/1","type":"function"},{"doc":"Type of Framestamp.Range.MixedOutTypeArithmeticError .","ref":"Vtc.Framestamp.Range.MixedOutTypeArithmeticError.html#t:t/0","title":"Vtc.Framestamp.Range.MixedOutTypeArithmeticError.t/0","type":"type"},{"doc":"A SMPTE Timecode Library for Elixir","ref":"readme.html","title":"vtc-ex","type":"extras"},{"doc":"A small preview of what Vtc has to offer. Note that printing statements like inspect/1 have been elided from the examples below. Vtc represents specific frames in a video stream as Framestamps , which can parsed from a number of different formats, including SMPTE timecode, frame count, and physical film length measured in feet and frames: iex&gt; Framestamp . with_seconds! ( 1.5 , Rates . f23_98 ( ) ) &quot;&lt;00:05:23:04 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; stamp = Framestamp . with_frames! ( &quot;17:23:13:02&quot; , Rates . f23_98 ( ) ) &quot;&lt;17:23:00:02 &lt;23.98 NTSC&gt;&gt;&quot; Once in a Framestamp struct, you convert to any of the supported formats: iex&gt; Framestamp . smpte_timecode ( stamp ) &quot;00:05:23:04&quot; iex&gt; Framestamp . frames ( stamp ) 1501922 iex&gt; Framestamp . feet_and_frames ( stamp ) &quot;&lt;93889+10 :ff35mm_4perf&gt;&quot; Comparisons and kernel sorting are supported, with many helper functions for specific comparisons: iex&gt; Framestamp . compare ( stamp , &quot;02:00:00:00&quot; ) :gt iex&gt; Framestamp . gt? ( stamp , &quot;02:00:00:00&quot; ) true iex&gt; stamp_01 = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; stamp_02 = Framestamp . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; data_01 = %{ id : 2 , tc : stamp_01 } iex&gt; data_02 = %{ id : 1 , tc : stamp_02 } iex&gt; [ data_02 , data_01 ] |&gt; Enum . sort_by ( &amp; &amp;1 . tc , Framestamp ) |&gt; inspect ( ) &quot;[%{id: 2, tc: &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}, %{id: 1, tc: &lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;}]&quot; All sensible arithmetic operations are provided, such as addition, subtraction, and multiplication: iex&gt; stamp = Framestamp . add ( tc , &quot;01:00:00:00&quot; ) &quot;&lt;18:23:13:02 &lt;23.98 NTSC&gt;&gt;&quot; You can even use native operators within special eval/2 blocks: iex&gt; Framestamp . eval at : 23.98 do iex&gt; stamp + &quot;00:30:00:00&quot; * 2 - &quot;00:15:00:00&quot; iex&gt; end &quot;&lt;19:08:13:02 &lt;23.98 NTSC&gt;&gt;&quot; Ranges let you operate on in/out points, for instance, finding the overlapping area between two ranges: iex&gt; a_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Framestamp.Range . new! ( a_in , &quot;02:00:00:00&quot; ) &quot;&lt;01:00:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; b_in = Framestamp . with_frames! ( &quot;01:45:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp.Range . new! ( b_in , &quot;02:30:00:00&quot; ) &quot;&lt;01:45:00:00 - 02:30:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; Framestamp.Range . intersection! ( a , b ) &quot;&lt;01:45:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"readme.html#demo","title":"vtc-ex - Demo","type":"extras"},{"doc":"Vtx ships with optional ecto types that can be used to accelerate you timecode workflow at the database level: ## Migration file defmodule MyApp.MySchema do @moduledoc false use Ecto.Migration alias Vtc.Ecto.Postgres.PgFramestamp alias Vtc.Framestamp def change do create table ( &quot;my_table&quot; , primary_key : false ) do add ( :id , :uuid , primary_key : true , null : false ) add ( :a , Framestamp . type ( ) ) add ( :b , Framestamp . type ( ) ) end end end ## Schema file defmodule Vtc.Test.Support.FramestampSchema01 do @moduledoc false use Ecto.Schema alias Ecto.Changeset alias Vtc.Framestamp @type t ( ) :: % __MODULE__ { id : Ecto.UUID . t ( ) , stamp_in : Framestamp . t ( ) , stamp_out : Framestamp . t ( ) } @primary_key { :id , Ecto.UUID , autogenerate : true } schema &quot;my_table&quot; do field ( :start , Framestamp ) field ( :end , Framestamp ) end @spec changeset ( % __MODULE__ { } , %{ atom ( ) =&gt; any ( ) } ) :: Changeset . t ( % __MODULE__ { } ) def changeset ( schema , attrs ) , do : Changeset . cast ( schema , attrs , [ :id , :stamp_in , :stamp_out ] ) end Values can be used in Ecto queries using the type/2 function. Vtc registers native operators for each type, so you can write queries like you would expect to: iex&gt; one_hour = Framestamp . with_frames ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; EdlEvents iex&gt; |&gt; where ( [ event ] , event . stamp_in &gt; type ( ^ one_hour , Framestamp ) ) iex&gt; |&gt; select ( [ event ] , { event , event . stamp_out - event . stamp_in } ) The above query finds all events with a start time greater than 01:00:00:00 and returns the record AND its calculated duration.","ref":"readme.html#ecto-types","title":"vtc-ex - Ecto types","type":"extras"},{"doc":"Check out the Quickstart Guide for a walkthrough of what Vtc offers for application-level code, and the Ecto Quickstart Guide for a deep-dive on working with Vtc's Postgres offerings. The API Reference offers a complete technical accounting of Vtc's capabilities.","ref":"readme.html#further-reading","title":"vtc-ex - Further Reading","type":"extras"},{"doc":"Offer a comprehensive set of tools for parsing, manipulating and rendering timecode with all it's quirks and incarnations. Define an intuitive, idiomatic Elixir API. Do all calculations in Rational representation, so there is both no drift or rounding errors when manipulating NTSC timecode, and we can represent time as finely as possible rather than being limited to the granularity of frame numbers. Be approachable for newcomers to the timecode problem space. Each function and concept in the API Reference includes a primer on what it is and where it is used in Film and Television workflow. Offer a flexible set of tools that support both rigorous, production-quality code and quick scratch scripts.","ref":"readme.html#goals","title":"vtc-ex - Goals","type":"extras"},{"doc":"SMPTE Conventions: [X] NTSC [X] Drop-Frame [ ] Interlaced timecode Timecode Representations: [X] Framestamp | 18018/5 seconds @ 24000/1001 [X] Timecode | '01:00:00:00' [X] Frames | 86400 [X] Seconds | 3600.0 [X] Runtime | '01:00:00.0' [X] Rational | 18018/5 [X] Feet+Frames | '5400+00' [X] 35mm, 4-perf [ ] 35mm, 3-perf [X] 35mm, 2-perf [X] 16mm [X] Premiere Ticks | 15240960000000 Operations: [X] Comparisons (==, &lt;, &lt;=, &gt;, &gt;=) [X] Add [X] Subtract [X] Scale (multiply and divide) [X] Divmod [X] Modulo [X] Negative [X] Absolute [X] Rebase (recalculate frame count at new framerate) [X] Native Operator Evaluation Flexible Parsing: [X] Partial timecodes | '1:12' [X] Partial runtimes | '1.5' [X] Negative string values | '-1:12', '-3+00' [X] Poorly formatted SMPTE timecode | '1:13:4' [X] Built-in consts for common framerates. [X] Configurable rounding options. [X] Support for standard library sorting behavior. [X] Range type for working with and comparing frame ranges. [X] Overlap between ranges [X] Distance between ranges [X] Inclusive and exclusive ranges [X] Postgres Composite Types with Ecto and Postgrex: Rational[X] [X] Native comparison operators [X] Native arithmetic operators [X] Native BTree index support Framerate[X] [X] Native comparison operators Framestamp[X] [X] Native comparison operators [X] Native arithmetic operators [X] Native BTree index support [X] Native inspection functions Framestamp.Range [X] Native GiST index support [X] Native inspection functions","ref":"readme.html#features","title":"vtc-ex - Features","type":"extras"},{"doc":"Drop-frame calculations adapted from David Heidelberger's blog . 35mm, 2perf and 16mm format support based on Jamie Hardt's work for vtc-rs . Logo made by Freepik from www.flaticon.com .","ref":"readme.html#attributions","title":"vtc-ex - Attributions","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding vtc to your list of dependencies in mix.exs : def deps do [ { :vtc , &quot;~&gt; 0.14&quot; } ] end","ref":"readme.html#installation","title":"vtc-ex - Installation","type":"extras"},{"doc":"Let's take a little peek at what Vtc can do, for you! Note that printing calls like inspect/1 have been elided from these examples. These are the three main modules that make up the Vtc API: alias Vtc.Framerate alias Vtc.Rates alias Vtc.Framestamp Let's start with a 23.98 NTSC timecode. We use the with_frames constructor here since timecode is really a human-readable way to represent frame count. The Vtc.Rates module defines a number of Vtc.Framerate values found in the wild. Most common, by far, is 23.98 NTSC , which is shorthand for video footage running at 24000/1001 frames-per-second. iex&gt; framestamp = Framestamp . with_frames! ( &quot;17:23:13:02&quot; , Rates . f23_98 ( ) ) &quot;&lt;17:23:00:02 &lt;23.98 NTSC&gt;&gt;&quot; Once we have a Vtc.Framestamp struct, we can render all sorts of commonly used framestamp representations, like SMPTE timecode:","ref":"quickstart.html","title":"Quickstart","type":"extras"},{"doc":"smpte_timecode/2 iex&gt; Framestamp . smpte_timecode ( framestamp ) &quot;17:23:00:02&quot; frames/2 iex&gt; Framestamp . frames ( framestamp ) 1501922 seconds iex&gt; framestamp . seconds &quot;Ratio.new(751711961, 12000)&quot; runtime/2 iex&gt; Framestamp . runtime ( framestamp , 3 ) &quot;17:24:15.676&quot; premiere_ticks/2 iex&gt; Framestamp . premiere_ticks ( framestamp ) 15915544300656000 physical film length in feet_and_frames/2 iex&gt; Framestamp . feet_and_frames ( framestamp ) &quot;&lt;93889+10 :ff35mm_4perf&gt;&quot;","ref":"quickstart.html#unit-conversions","title":"Quickstart - Unit Conversions","type":"extras"},{"doc":"ntsc iex&gt; framestamp . rate . ntsc :non_drop playback speed iex&gt; framestamp . rate . playback &quot;Ratio.new(24000, 1001)&quot; timebase/1 logical speed iex&gt; Framerate . smpte_timebase ( framestamp . rate ) 24 .","ref":"quickstart.html#framerate-information","title":"Quickstart - Framerate Information","type":"extras"},{"doc":"Parsing is flexible, we can pass in partial or malformed timecode. In Vtc , there are only two ways to parse framestamps, either with Timecode.with_frames/2 for formats that represent a discrete frame count, or Timecode.with_seconds/2 for formats that represent a number of real-world, elapsed seconds were those frames to be played back at the framestamp's rate.","ref":"quickstart.html#parsing","title":"Quickstart - Parsing","type":"extras"},{"doc":"Frames Formats timecode iex&gt; Framestamp . with_frames! ( &quot;3:12&quot; , Rates . f23_98 ( ) ) &quot;&lt;03:00:00:12 &lt;23.98 NTSC&gt;&gt;&quot; malformed timecode iex&gt; Framestamp . with_frames! ( &quot;3:12&quot; , Rates . f23_98 ( ) ) &quot;&lt;03:00:00:12 &lt;23.98 NTSC&gt;&gt;&quot; frame count iex&gt; Framestamp . with_frames! ( 24 , Rates . f23_98 ( ) ) &quot;&lt;00:00:01:00 &lt;23.98 NTSC&gt;&gt;&quot; physical film length in feet+frames iex&gt; Framestamp . with_frames! ( &quot;1+08&quot; , Rates . f23_98 ( ) ) &quot;&lt;00:00:01:00 &lt;23.98 NTSC&gt;&gt;&quot; Seconds Formats seconds iex&gt; Framestamp . with_seconds! ( 1.5 , Rates . f23_98 ( ) ) &quot;&lt;00:05:23:04 &lt;23.98 NTSC&gt;&gt;&quot; runtime iex&gt; Framestamp . with_seconds! ( &quot;00:05:23.5&quot; , Rates . f23_98 ( ) ) &quot;&lt;00:05:23:04 &lt;23.98 NTSC&gt;&gt;&quot; malformed runtime iex&gt; Framestamp . with_seconds! ( &quot;5:23.5&quot; , Rates . f23_98 ( ) ) &quot;&lt;00:05:23:04 &lt;23.98 NTSC&gt;&gt;&quot; premiere ticks iex&gt; input = % PremiereTicks { in : 254_016_000_000 } iex&gt; Framestamp . with_seconds! ( input , Rates . f23_98 ( ) ) &quot;&lt;00:00:01:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"quickstart.html#examples","title":"Quickstart - Examples","type":"extras"},{"doc":"By default, feet+frames is interpreted as 35mm, 4perf film. You can use the FeetAndFrames struct to parse other film formats. 16mm feet + frames iex&gt; alias Vtc.Source.Frames.FeetAndFrames iex&gt; iex&gt; { :ok , feet_and_frames } = FeetAndFrames . from_string ( &quot;5400+00&quot; , film_format : :ff16mm ) iex&gt; iex&gt; Framestamp . with_frames ( feet_and_frames , Rates . f23_98 ( ) ) &quot;{:ok, &lt;01:15:00:00 &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"quickstart.html#other-film-formats","title":"Quickstart - Other film formats","type":"extras"},{"doc":". add/3 iex&gt; a = Framestamp . with_frames! ( &quot;18:23:13:02&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; framestamp = Framestamp . add ( a , b ) &quot;&lt;18:23:13:02 &lt;23.98 NTSC&gt;&gt;&quot; add/3 with string iex&gt; Framestamp . add ( tc , &quot;00:10:00:00&quot; ) &quot;&lt;18:33:13:02 &lt;23.98 NTSC&gt;&gt;&quot; add/3 with ints means adding frames iex&gt; Framestamp . add ( tc , 38 ) &quot;&lt;18:33:14:16 &lt;23.98 NTSC&gt;&gt;&quot; sub/3 iex&gt; Framestamp . sub ( tc , &quot;01:00:00:00&quot; ) &quot;&lt;17:33:14:16 &lt;23.98 NTSC&gt;&gt;&quot; . minus/1 iex&gt; Framestamp . minus ( framestamp ) &quot;&lt;-17:33:14:16 &lt;23.98 NTSC&gt;&gt;&quot; abs/1 iex&gt; Framestamp . abs ( framestamp ) &quot;&lt;17:33:14:16 &lt;23.98 NTSC&gt;&gt;&quot; mult/3 iex&gt; Framestamp . mult ( framestamp , 2 ) &quot;&lt;35:06:29:08 &lt;23.98 NTSC&gt;&gt;&quot; div/3 iex&gt; Framestamp . div ( framestamp , 2 ) &quot;&lt;17:33:14:16 &lt;23.98 NTSC&gt;&gt;&quot; divrem/3 iex&gt; { dividend , remainder } = Framestamp . divrem ( framestamp , 3 ) iex&gt; { dividend , remainder } &quot;{&lt;05:51:04:21 &lt;23.98 NTSC&gt;&gt;, &lt;00:00:00:01 &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"quickstart.html#arithmetic","title":"Quickstart - Arithmetic","type":"extras"},{"doc":"Special Framestamp.eval do blocks let us use native operators. eval/2 iex&gt; require Framestamp iex&gt; iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;00:30:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; c = Framestamp . with_frames! ( &quot;00:15:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; Framestamp . eval do iex&gt; a + b * 2 - c iex&gt; end &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; Or even do some quick scratch calculations in a given framerate: scratch calculation iex&gt; Framestamp . eval at : 23.98 do iex&gt; &quot;01:00:00:00&quot; + &quot;00:30:00:00&quot; * 2 - &quot;00:15:00:00&quot; iex&gt; end &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"quickstart.html#eval","title":"Quickstart - Eval","type":"extras"},{"doc":"We can make drop-frame framestamps for 29.97 or 59.94 using one of the pre-set framerates. drop-frame iex&gt; Framestamp . with_frames! ( 15_000 , Rates . f29_97_df ( ) ) &quot;&lt;00:08:20;18 &lt;29.97 NTSC DF&gt;&gt;&quot; We can make new framestamps with arbitrary framerates if we want. non-ntsc iex&gt; Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Framerate . new! ( 240 , nil ) ) &quot;&lt;01:00:00:00 &lt;240.0 fps&gt;&gt;&quot; Using :non_drop indicates this framestamp represents an NTSC timecode, and will convert whole-number timebases to the correct speed. non-drop coercion iex&gt; Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Framerate . new! ( 48 , :non_drop ) ) &quot;&lt;01:00:00:00 &lt;47.95 NTSC&gt;&gt;&quot; We can also rebase the frames using a new framerate! rebase iex&gt; Framestamp . rebase ( tc , Rates . f23_98 ( ) ) &quot;&lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"quickstart.html#framerates","title":"Quickstart - Framerates","type":"extras"},{"doc":"It's easy to compare two framestamps. compare/2 iex&gt; a = Framestamp . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; Framestamp . compare ( a , b ) :lt There a host of other specific comparison functions like eq?/2 , gt?/2 that return booleans. Specific comparison iex&gt; Framestamp . lt? ( a , b ) true Like arithmetic, we can compare directly with a timecode string: compare/2 with string iex&gt; Framestamp . compare ( a , &quot;00:59:00:00&quot; ) :gt Sorting is supported through the compare/2 function. sort through Framestamp iex&gt; framestamp_01 = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; framestamp_02 = Framestamp . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; data_01 = %{ id : 2 , tc : framestamp_01 } iex&gt; data_02 = %{ id : 1 , tc : framestamp_02 } iex&gt; iex&gt; Enum . sort_by ( [ data_02 , data_01 ] , &amp; &amp;1 . tc , Framestamp ) &quot;[%{id: 2, tc: &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}, %{id: 1, tc: &lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;}]&quot;","ref":"quickstart.html#comparisons-and-sorting","title":"Quickstart - Comparisons and Sorting","type":"extras"},{"doc":"Range helps with common operations using in/out points. Let's set two of those up. new/3 iex&gt; a_in = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a_out = Framestamp . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; a = Framestamp.Range . new! ( a_in , a_out ) &quot;&lt;01:00:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot; By default, ranges are exclusive , meaning the out point represents the boundary where the clip ends, not the final frame that is part of the video clip. This way will be familiar to Premiere and Final Cut editors. But fear not, our Avid brethren, inclusive out points like you are used to are available as well! Just like addition, we can write a bare timecode string as the out value if we want. new/3 with string iex&gt; b_in = Framestamp . with_frames! ( &quot;01:45:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; b = Framestamp.Range . new! ( b_in , &quot;02:30:00:00&quot; ) &quot;&lt;01:45:00:00 - 02:30:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot; We can get the duration of a range. duration/1 iex&gt; Framestamp.Range . duration ( b ) iex&gt; &quot;&lt;00:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; ... see if a specific framestamp is in a range: contains?/2 iex&gt; Framestamp.Range . contains? ( b , &quot;02:00:00:00&quot; ) iex&gt; true ... or see if it overlaps with another range. overlaps?/2 iex&gt; Framestamp.Range . overlaps? ( a , b ) iex&gt; true We can even get the overlapping area as its own range! intersection/2 iex&gt; Framestamp.Range . intersection! ( a , b ) &quot;&lt;01:45:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"quickstart.html#ranges","title":"Quickstart - Ranges","type":"extras"},{"doc":"To include Postgres types with Ecto. Add the following into you applications configuration file: config :vtc , env : config_env ( ) , include_postgres_types? : true See each Postgres type for information on it's configuration.","ref":"quickstart.html#postgres-types","title":"Quickstart - Postgres Types","type":"extras"},{"doc":"Vtc ships with a number of Ecto custom types designed to work with Postgres databases connected by Postgrex .","ref":"ecto_quickstart.html","title":"Ecto Quickstart","type":"extras"},{"doc":"The custom Ecto &amp; Postgres types provided by Vtc are: PgRational Migrations Schema Not re-exported, Ratio is not owned by Vtc. PgFramerate Migrations Schema Re-exported by Framerate PgFramestamp Migrations Schema Re-exported by Framestamp PgFramestamp.Range Migrations Schema Re-exported by Framestamp.Range","ref":"ecto_quickstart.html#ecto-types","title":"Ecto Quickstart - Ecto types","type":"extras"},{"doc":"To enable ecto types in your application, set the following in your config/config.exs file: config :vtc , Postgrex , include? : true Without this setting, Vtc's Ecto modules will not compile when you compile your app. Once you have Postgrex types enabled, additional configuration is done at the Repo level: config :vtc , Vtc.Test.Support.Repo , adapter : Ecto.Adapters.Postgres , vtc : [ rational : [ functions_schema : :rational , functions_prefix : &quot;&quot; ] , framerate : [ functions_schema : :framerate , functions_prefix : &quot;&quot; ] , framestamp : [ functions_schema : :framestamp , functions_prefix : &quot;&quot; ] , framestamp_range : [ functions_schema : :framestamp_range , functions_prefix : &quot;&quot; ] ] config :vtc , ecto_repos : [ Vtc.Test.Support.Repo ] Each type can be configured to store it's support functions on a schema of your choice as well as have a custom, per-type function name prefix. By default, all functions are added to the public schema, and are prefaced by their type name. For example, the PgFramestamp frames function is created in the public schema, and named framestamp_frames .","ref":"ecto_quickstart.html#configuration","title":"Ecto Quickstart - Configuration","type":"extras"},{"doc":"To create all the Postgres types, functions, operators, casts, and operator classes that Vtc provides, run the following migration: defmodule Vtc.Test.Support.Repo.Migrations.AddPostgresTypes do @moduledoc false use Ecto.Migration def change do Vtc.Ecto.Postgres.Migrations . migrate ( ) end end This migration is safe to run multiple times, and can be run again when new functionality is added to Vtc. All migrations implement both up and down functionality, and support rollbacks out of the box. All objects created by the migration come complete with in-database documentation with links to the relevant Vtc docs. Using DataGrip :","ref":"ecto_quickstart.html#initial-migration","title":"Ecto Quickstart - Initial Migration","type":"extras"},{"doc":"Vtc's custom Ecto types are each implemented in a dedicated module. For instance, the framestamp type is implemented by PgFramestamp . However, each ecto type's functions are re-exported by the Vtc elixir type it is designed to work with, allowing you to mostly ignore the dedicated ecto module when creating migrations and schemas: defmodule MyApp.MySchema do @moduledoc false use Ecto.Migration alias Vtc.Ecto.Postgres.PgFramestamp alias Vtc.Framestamp def change do create table ( &quot;my_table&quot; , primary_key : false ) do add ( :id , :uuid , primary_key : true , null : false ) add ( :a , Framestamp . type ( ) ) add ( :b , Framestamp . type ( ) ) end end end Each type ships with a set of custom constraints that can be used for data integrity validation in migrations: Framestamp constraint docs def change do create table ( &quot;my_table&quot; , primary_key : false ) do add ( :b , Framestamp . type ( ) ) end PgFramestamp.Migrations . create_constraints ( &quot;my_table&quot; , :b ) end Vtc modules can be used directly in schemas: Framestamp changeset casting docs defmodule Vtc.Test.Support.FramestampSchema01 do @moduledoc false use Ecto.Schema alias Ecto.Changeset alias Vtc.Framestamp @type t ( ) :: % __MODULE__ { id : Ecto.UUID . t ( ) , a : Framestamp . t ( ) , b : Framestamp . t ( ) } @primary_key { :id , Ecto.UUID , autogenerate : true } schema &quot;my_table&quot; do field ( :a , Framestamp ) field ( :b , Framestamp ) end @spec changeset ( % __MODULE__ { } , %{ atom ( ) =&gt; any ( ) } ) :: Changeset . t ( % __MODULE__ { } ) def changeset ( schema , attrs ) , do : Changeset . cast ( schema , attrs , [ :id , :a , :b ] ) end Values can be used in Ecto queries using the type/2 function. Vtc registers native operators for each type, so you can write queries like you would expect to with any other numeric type: query value iex&gt; one_hour = Framestamp . with_frames ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; EdlEvents iex&gt; |&gt; where ( [ event ] , event . start &gt; type ( ^ one_hour , Framestamp ) ) iex&gt; |&gt; select ( [ event ] , { event , event . end - event . in_framestamp } ) The above query finds all events with a start time greater than 01:00:00:00 and returns the record AND its calculated duration.","ref":"ecto_quickstart.html#ecto-api","title":"Ecto Quickstart - Ecto API","type":"extras"},{"doc":"Many of Vtc's postgres functions are prefaced with __private__ , for instance, the framestamp__private__add function is used to back the addition + operator. These functions have no API stability guarantee, and callers should avoid calling them directly.","ref":"ecto_quickstart.html#private-functions","title":"Ecto Quickstart - Private functions","type":"extras"},{"doc":"with_seconds/2 Elixir iex&gt; seconds = Ratio . new ( 3600 ) iex&gt; rate = Rates . f23_98 ( ) iex&gt; iex&gt; query = iex&gt; Query . from ( iex&gt; f in fragment ( iex&gt; &quot;SELECT framestamp.with_seconds(?, ?) as r&quot; , iex&gt; type ( ^ seconds , PgRational ) , iex&gt; type ( ^ rate , Framerate ) iex&gt; ) , iex&gt; select : f . r iex&gt; ) iex&gt; iex&gt; query |&gt; Repo . one! ( ) |&gt; Framestamp . load ( ) |&gt; inspect ( ) &quot;{:ok, &lt;00:59:56:10 &lt;23.98 NTSC&gt;&gt;}&quot; SQL SELECT framestamp.with_seconds( (3600, 1)::rational, ((24000, 1001), '{non_drop}')::framerate ); Output: with_seconds ------------------------------------------------------ (43200157,12000,24000,1001,{non_drop}) (1 row) Notice that just like Framestamp.with_seconds/3 , the seconds value is rounded to the nearest whole-frame on construction. with_frames/2 Elixir iex&gt; frames = 24 iex&gt; rate = Rates . f23_98 ( ) iex&gt; iex&gt; query = iex&gt; Query . from ( iex&gt; f in fragment ( iex&gt; &quot;SELECT framestamp.with_frames(?, ?) as r&quot; , iex&gt; ^ frames , iex&gt; type ( ^ rate , Framerate ) iex&gt; ) , iex&gt; select : f . r iex&gt; ) iex&gt; iex&gt; query |&gt; Repo . one! ( ) |&gt; Framestamp . load ( ) |&gt; inspect ( ) &quot;{:ok, &lt;00:00:01:00 &lt;23.98 NTSC&gt;&gt;}&quot; SQL SELECT framestamp.with_frames( 24, ((24000, 1001), '{non_drop}')::framerate ); Output: with_frames ------------------------------------------------- (1001,1000,24000,1001,{non_drop}) (1 row) frame count Elixir iex&gt; stamp = iex&gt; Framestamp . with_frames! ( iex&gt; &quot;01:00:00:00&quot; , iex&gt; Rates . f23_98 ( ) iex&gt; ) iex&gt; iex&gt; query = iex&gt; Query . from ( iex&gt; f in fragment ( iex&gt; &quot;SELECT framestamp.frames(?) as r&quot; , iex&gt; type ( ^ stamp , Framestamp ) iex&gt; ) , iex&gt; select : f . r iex&gt; ) iex&gt; iex&gt; Repo . one! ( query ) 86400 SQL SELECT framestamp.frames( (18018, 5, 24000, 1001, '{non_drop}') ); Output: frames -------- 86400 (1 row)","ref":"ecto_quickstart.html#framestamp-postgres-functions","title":"Ecto Quickstart - Framestamp Postgres functions","type":"extras"},{"doc":"Available operators name type args result description = operator framestamp , framestamp boolean true if a seconds == b seconds &lt; operator framestamp , framestamp boolean true if a seconds &lt; b seconds &lt;= operator framestamp , framestamp boolean true if a seconds &lt;= b seconds &gt; operator framestamp , framestamp boolean true if a seconds &gt; b seconds &gt;= operator framestamp , framestamp boolean true if a seconds &gt;= b seconds ABS function framestamp framestamp absolute value @ operator framestamp framestamp absolute value - function framestamp framestamp negate. flips input's sign + operator framestamp , framestamp framestamp addition. raises if framerates do not match @+ operator framestamp , framestamp framestamp addition. inherit framerate from left +@ operator framestamp , framestamp framestamp addition. inherit framerate from right - operator framestamp , framestamp framestamp subtraction. raises if framerates do not match @- operator framestamp , framestamp framestamp subtraction. inherit framerate from left -@ operator framestamp , framestamp framestamp subtraction. inherit framerate from right * operator framestamp , rational framestamp multiplication. rounds to nearest whole-frame / operator framestamp , rational framestamp division. rounds to nearest frame DIV function framestamp , rational framestamp floor-division. rounds down to nearest frame % operator framestamp , rational framestamp remainder. returns leftover frames from DIV . Mixed rate arithmetic Elixir iex&gt; a = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Framestamp . with_frames! ( &quot;01:00:00:00&quot; , Rates . f47_95 ( ) ) iex&gt; iex&gt; query = iex&gt; Query . from ( iex&gt; f in fragment ( iex&gt; &quot;SELECT &quot; ? + @ ? as r &quot;, iex&gt; type(^a, Framestamp), iex&gt; type(^b, Framestamp) iex&gt; ), iex&gt; select: f.r iex&gt; ) iex&gt; iex&gt; Repo.one!(query) |&gt; Framestamp.load() |&gt; inspect() &quot; { :ok , &lt; 02 : 00 : 00 : 00 &lt; 47.95 NTSC &gt;&gt; } &quot; SQL SELECT (18018, 5, 24000, 1001, '{non_drop}')::framestamp +@ (18018, 5, 48000, 1001, '{non_drop}')::framestamp; Output: ?column? ----------------------------------------------- (&quot;(36036,5)&quot;,&quot;(&quot;&quot;(48000,1001)&quot;&quot;,{non_drop})&quot;) (1 row)","ref":"ecto_quickstart.html#framestamp-postgres-operators","title":"Ecto Quickstart - Framestamp Postgres operators","type":"extras"},{"doc":"But first: what is timecode? If you're already familiar with timecode, it's history, and it's flavors, feel free to skip this section.","ref":"history.html","title":"Timecode: A History","type":"extras"},{"doc":"Back in the days of film, a running strip of numbers ran along the edge of the film stock to uniquely identify each frame, called keycode Keycode was essential to the film editing process. The raw negative of a film is irreplaceable: you loose quality each time you make a copy. Editing film is necessarily a destructive process , and often required multiple iterations. It would be just a tad nerve-wracking to take a pair of scissors and some glue to the one-of-a-kind film reels straight out of the camera on set, then running it over and over through a flatbed. To avoid potential disaster, editors made their cut of the film using copies of the raw negative, called a work print , allowing the editor to work without fear of sinking a project from slicing, dicing, and wearing at the film. When the edit was complete, it was necessary to know exactly where the edits had been made, so it could be recreated with the raw negative for finishing. A cut list would be written out, with the exact reels and keycodes for every cut, and would be used to make an exact duplicate of the editor's work print with the mint condition raw negative. In video and digital filmmaking, the same approach is used. Massive RAW files from a RED, ARRI, Sony, or other cinema camera are rendered down to more manageable files an Editor's machine won't choke on. Once the edit is complete, the raw files are re-assembled using a digital cutlist on a powerful machine for finishing out the film. In film, we referenced keycode to know exactly what frame was being displayed on screen at any given time. In digital video, we reference the timecode of a given frame, as defined by the SMPTE Timecode standard.","ref":"history.html#how-we-got-here","title":"Timecode: A History - How we got here","type":"extras"},{"doc":"For a technical deep-dive into the many flavors of timecode, check out Frame.io's excellent blog post on the subject.","ref":"history.html#further-reading","title":"Timecode: A History - Further Reading","type":"extras"},{"doc":"To understand timecode, first we need to understand the difference between framerate, the rate at which a piece of media is actually yielding frames, and timebase, the rate at which we pretend that media is yielding frames when rendering a SMPTE timecode value. Timecode does not -- counterintuitively -- represent the TIME of a frame. Instead, it is a human-digestible INDEX of that frame in the sequence of all frames that make up a video clip, just like keycode before it. It's fields are NOT hours, minutes, seconds, and milliseconds , as you might expect from a time-based format; they are &quot;hours&quot;, &quot;minutes&quot;, &quot;seconds&quot;, and frames (more on the airquotes later). Timecode is more UUID than timestamp.","ref":"framerate_vs_timebase.html","title":"NTSC: Framerate vs Timebase","type":"extras"},{"doc":"For true-frame video -- that is, video where frames never cross the boundary of a given second -- this distinction doesn't matter. When recording at 24.0fps true, the 23rd frame recorded is 00:00:00:23 and the 24th frame recorded is 00:00:01:00 , SMPTE timecode, which lines up with 00:00:01.0 in real-world hours, minutes, and seconds. Here is the catch -- because there is a catch -- the vast majority of video these days are not recorded in mathematically convenient framerates. They are recorded at framerates defined by the SMPTE NTSC standard. You can read a deep-dive on that standard here , but the long and short of it is that cinema video is almost always recorded rates commonly referred to as 23.98 , 29.97 , 59.84 , etc. that are fractionally slower than their 24.0 , 30.0 , 60.0 , etc. counterparts. When trying to figure out how to map NTSC frames to a frame-specific timestamp, attempting to conform to the real world becomes difficult. the 24th frame of 23.98, NTSC timecode actually occurs at 00:00:01.001 . If we want a discreet 'frames' place, do we then need to drop frames from some seconds to keep them in-line with a real world clock? Unsurprisingly, some timecode displays do exactly that. NTSC drop-frame timecode takes this approach, and is a nightmare to work with outside the very specific use case of measuring the length of an edit. Thankfully, drop-frame conventions are out of favor these days, and only defined for 29.97 and 59.94 framerates -- the framerates that were used for analogue video and older broadcast television.","ref":"framerate_vs_timebase.html#not-fitting-neatly-into-seconds","title":"NTSC: Framerate vs Timebase - (Not) fitting neatly into seconds","type":"extras"},{"doc":"NTSC non-drop timecode is the favored convention today. Non-drop timecode, as the name suggests, does not drop frames to keep it's &quot;timestamp&quot; in sync with the real-world clock. Instead, it chooses to believe a convenient lie that all 24 frames in a &quot;second&quot; actually fit in that second, and renders timecode accordingly, with each &quot;second&quot; starting at frame 00 and ending at frame 23 . Drift from the real-world clock is taken as a necessary sin in exchange for not having to manage drop frames. 01:00:00:00 in 23.98 NTSC, non-drop timecode represents 01:00:03.6 in real-world hours, minutes, and seconds.","ref":"framerate_vs_timebase.html#seconds-aren-t-seconds","title":"NTSC: Framerate vs Timebase - &quot;Seconds&quot; aren't Seconds","type":"extras"},{"doc":"Vtc calls the true, real-world framerate of the media -- in this example 24000/1001 -- the playback rate of the timecode. The rate at which timecode is calculated, -- in this example 24/1 -- is called the timebase . But wait -- why are we using fractions all of a sudden? That's because the common way we refer to NTSC framerates -- i.e 23.98 NTSC -- is actually rounded shorthand for it's actual specification: 24000/1001 . We will examine the inherently rational nature of timecode calculations in the next section.","ref":"framerate_vs_timebase.html#vtc-terminology","title":"NTSC: Framerate vs Timebase - Vtc Terminology","type":"extras"},{"doc":"Vtc uses rational (fraction) values to represent both timecode and framerate. Why? Rational values are not oft used in computer science, and less efficient than finding a way to represent your value as either a float or an integer scalar. Video media programs have employed a variety of strategies to numerically representing framerate and timecode -- that is to say frame identifiers -- with varying success. In this document, we will lay out some of the historical approaches, and then examine the reasoning behind Vtc's solution.","ref":"the_rational_rationale.html","title":"The Rational Rationale","type":"extras"},{"doc":"First, a brief distillation of Vtc's goals: Lossless casting in and out of timecode strings No rounding errors when adding or subtracting, or multiplying timecode values Math and comparisons must be frame-accurate in mixed rate contexts Comparisons between timecodes should be based on the real-world time a frame was recorded assuming jam-sync .","ref":"the_rational_rationale.html#requirements","title":"The Rational Rationale - Requirements","type":"extras"},{"doc":"23.98 NTSC timecode is specified as running at 24000/1001 frames per second, with timecode calculated AS IF it were running at 24fps . 24000/1001 has the unfortunate property of being an irrational number. It's digits ride off into the sunset, never terminating: iex&gt; 24_000 / 1001 23.976023976023978 This unfortunate mathematical reality has a number of unfortunate knock-on effects when attempting to model frame-accurate timecode calculations.","ref":"the_rational_rationale.html#ntsc-and-digital-computing","title":"The Rational Rationale - NTSC and Digital Computing","type":"extras"},{"doc":"If you look up the NTSC spec, you may notice that it ACTUALLY defines 23.98 NTSC with floats: 24000.0/1001.0 . So what gives? Why do we need more accuracy than the way video equipment represents its frame identifiers internally? When a camera or single-rate video editor is is producing frame timecodes, it is doing so from a frame number. Because those frame numbers are being generated sequentially, and ALWAYS in the context of a uniform frame rate, we can essentially ignore the small amount of real-world jitter that a video stream contains, and there will never be enough precision loss that rounding to the nearest frame will be wrong. But when trying to do theoretical calculation between in-and-out points, like when manipulating and EDL that dense data becomes sparse data, and we need to make sure we are doing our math in a way that does not lose a frame to precision issues, that can't misplace a frame when doing math between frames as points .","ref":"the_rational_rationale.html#but-wait","title":"The Rational Rationale - But wait...","type":"extras"},{"doc":"Let's review how programs have historically attempted to grapple with timecode, and how they fail to meet the requirements above. Frame integer : One common approach to tacking timecode is to represent it as a frame number with 0 standing for 00:00:00:00 and 24 standing for 00:00:01:00 (at 23.98 ). The problem with this approach is that in mixed-rate scenarios, these values cannot be easily sorted by the real-world time that the frame was captured, and therefore are not suited to tasks like syncing multicams, or audio where cameras were recording at multiple framerates. For instance, 00:00:00:23 @ 23.98 and 00:00:00:46 @ 47.95 both represent the same real-world time, but would be represented as 23 and 46 respectively. Seconds float : Another common technique is to do all arithmetic in floating point, and represent the timecode as a seconds value. So 00:00:02:00 would be represented as 48.0 frames / (24000.0/1001.0) fps = 2.002 seconds . Most cameras calculate a their Timecode values this way, and the official NTSC specification uses floats to define 24000.0/1001.0 as the 23.98 NTSC framerate. This works great when you are calculating each timecode frame-by-frame. You take each frame number and after 23.976023976023978 seconds, you record the frame buffer and generate a new Timecode for that frame's index. No frames are skipped. Likewise, when casting in and out of timecode strings, there isn't enough precision loss for errors to occur. But when you start adding timecodes together... errors can happen. Let's take a timecode of 00:00:00:23 . If we convert it to seconds, we get: iex&gt; seconds = 23 / ( 24_000 / 1001 ) 0.9592916666666667 Now let's say we have five events that we want to get the total length of, each is 23 seconds long. At the end we cast back to frames so we can construct the timecode: iex&gt; ( seconds + seconds + seconds + seconds + seconds ) * ( 24_000.0 / 1001.0 ) 115.00000000000001 We are just a little bit off. For this particular calculation, rounding gets us back to the correct answer, but over the course of thousands of operations, say for summing the duration of all events in an EDL, it adds up. We cannot cast back to frames to make this correction after every operation in mixed frame contexts either. Floats can also cause comparison errors in mixed framerate contexts. Let's imagine we have one camera on set recording at 119.88 NTSC , and one camera recording at 23.98 NTSC . For both cameras, 23:13:13:00 should equal the same real-world time. But if we convert the timecode stamps to real-world seconds as a float by calculating the frame number and dividing by the frame rate: iex&gt; # 23.98 NTSC iex&gt; 2_006_232 / ( 24_000 / 1001 ) 83676.593 iex&gt; # 23.98 NTSC iex&gt; 10_031_160 / ( 120_000 / 1001 ) 83676.59300000001 Although these values SHOULD be equivalent, they are not. For applications that require frame-accurate timecode comparisons, this approach will not work, something video editors have historically struggled with. Avid, for instance, disallowed mixed-rate timelines for years, forcing users to transcode their media to a uniform rate before they could edit it together. Quantized time Some programs attempt to define a minimum discreet time unit, such as a millisecond, nanosecond, etc, and capture timecode as a scalar value of that unit. Premiere, for instance, represents timecode as a &quot;tick&quot;, which it defines as a 254_016_000_000th of a second. Video clip in, out, and duration values are all converted to a tick integer value. This approach can cause rounding issues when generating EDLs, FCP7 XMLs, AAFs and others. Although in recent times the program has gotten much better, Premiere originally had a number of off-by-one errors when it first started supporting professional video workflows via interchange formats, ESPECIALLY when the framerate of the media did not match the framerate of the edit sequence. Again, 1 frame in 23.98 is equal to 0.04170833333333333 seconds. The digits value is not easily representable as a discreet time value, and choosing an arbitrary quanta for time means that the true frame time of a video clip of an arbitrary framerate may not always neatly line up with the boundaries of your unit, causing gradual drift when you start doing math.","ref":"the_rational_rationale.html#historical-approaches","title":"The Rational Rationale - Historical Approaches","type":"extras"},{"doc":"Lastly, it is important to note that Vtc does NOT strive to be as efficient as possible. Timecode manipulation -- when needed -- is not an operation that most programs needs to be done on the scale of millions of times per second, and will certainly not account for the majority of calculations that a program will be doing at any given step. Therefore, we believe that the loss in efficiency is worth the gain in accuracy and ease of use that Rational values provide. However, it is good to keep in mind that each time a rational value is produces the operation will involve multiple sub-operations. In the case of addition: three multiplication, then recursive division to simplify the fraction.","ref":"the_rational_rationale.html#on-efficiency","title":"The Rational Rationale - On Efficiency","type":"extras"},{"doc":"Vtc chose rational representation of timecode as a frame-accurate way to deal with timecode values in mixed rate contexts. In short, we PUT OFF the step of casting to a discreet value like a float, tick, millisecond, etc until AFTER we are done making calculations, conserving -- as accurately as possible -- a true, frame-accurate time.","ref":"the_rational_rationale.html#conclusion","title":"The Rational Rationale - Conclusion","type":"extras"},{"doc":"NOTE: This document is under developement.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"Please make pull requests based off the dev branch into the dev branch. The release CI pipleine adds additional files to the main branch whenever a PR is merged.","ref":"contributing.html#making-a-pr","title":"Contributing - Making a PR","type":"extras"},{"doc":"To run all linters that will be run in CI: make line You'll need to install the following non-elixir programs: misspell","ref":"contributing.html#running-lints","title":"Contributing - Running lints","type":"extras"},{"doc":"To run all tests with coverage reports: make test Vtc offers optional Postgres extensions. If you do not have a Posgres instanve running locally you can skip those tests like so: mix test -- exclude :postgres Or: mix test -- exclude :ecto","ref":"contributing.html#running-tests","title":"Contributing - Running tests","type":"extras"}]